#include "seamless3d.h"
#include "script.h"
//g_bindSmlsFile contains the URL to our .smls file we want to bind to
String g_bindSmlsFile="F:\\Content\\techuelife_island_smls\\debug-main-no-script.smls";
extern "C" float bridgeGetLandHeight(void* func, float x, float z);
extern "C" void bridgeTargetLandingSub(void* func);

extern ScenePtr g_scene;

//insert global variables here:

class ScriptBind{//user definable class for binding nodes and containing script functions
public:
	//define node references to match nodes that will be found in the .smls file

	Viewpoint& hoppyVP;
	IndexedFaceSet& geometry;
	Coordinate& coord;
	Normal& normal;
	Transform& ROOT;
	Transform& lFootRotY;
	Transform& lFoot;
	Transform& foot0;
	Transform& legTilt;
	Transform& lAnkleRotY;
	Transform& l_ankle;
	Transform& l_knee;
	Shape& LegSeg;
	Transform& torso1;
	Transform& torso0;
	Transform& l_eyestem_base;
	Shape& HoppyEyeStemSed;
	ImageTexture& robotTexture;
	Transform& l_eyestem_joint1;
	Transform& l_eyestem_joint2;
	Transform& l_eyeball;
	Shape& eye_ball;
	Transform& r_eyestem_base;
	Transform& r_eyestem_joint1;
	Transform& r_eyestem_joint2;
	Transform& r_eyeball;
	Transform& l_arm;
	Shape& hoppy_arm;
	Transform& l_hand;
	///////////////
	M_Vec3f& Coord;
	M_Vec3f& Norm;
	M_Int& Indices;
	int& landStrips;
	int& landEdgePntCnt;
	float& landSquareSize;
	float& oneDivByLandSquareSize;
	float& halfLSS;
	int& NumVertices;
	float& LandCXZ;
	float& LandTrans;
	///////////////
	Vec3f& Pos;
	Vec3f& ActualPos;
	Vec3f& LastRisingPos;
	Vec3f& JumpStartPos;
	Vec3f& TargetLandingPos;
	Vec3f& FutureLastRisingPos;
	int& HoppyStillPhase;
	int& HoppyRisingPhase;
	int& HoppyAirbornePhase;
	int& HoppyLandingPhase;
	int& Phase;
	bool& Startflag;
	double& StrtTime;
	float& gForce;
	float& gTime;
	bool& Move;
	float& JumpStartTime;
	float& TargetLandingTime;
	float& PrevTime;
	float& Yangle;
	float& ActualYangle;
	float& FinalYVelocity;
	float& FinalZVelocity;
	float& hya;
	float& CorrectHya;
	float& LandingCorrectHya;
	float& OverShootS;
	float& HopEndOverShootS;
	float& LandingAcceleration;
	float& ySPointOfTakeOff;
	float& ySPointOfLand;
	float& TempDist;
	float& FootPosy;
	float& TargetLandingYDiff;
	float& RisingPeriod;
	float& AirbornePeriod;
	float& TurnSpeed;
	float& fOneDivCirTwoPI;
	float& EyeWaveCycle;
	float& L_FwheelAng;
	float& R_FwheelAng;
	float& BwheelAng;
	float& JumpStartFootAngleX;
	float& JumpStartFootAngleZ;
	float& FootAngleX;
	float& FootAngleZ;
	float& FutureFootAngleXDiff;
	float& FutureFootAngleZDiff;
	float& yVelCorection;
	float& ToeLen;
	float& Speed;
	float& LegLength;
	float& FlatFinalYVelocity;
	float& abit;
	float& FinalTurnAngle;
	float& InitHopChy;
	float& LandingVelocity;


	Vec3f& TargetLandingFootPos;


	Function* getLandHeightFunc = 0;
	Function* TargetLandingSubFunc = 0;


	ScriptBind(//bind the nodes from the smls file to the ScriptBind class
		Viewpoint& hoppyVP,
		IndexedFaceSet& geometry,
		Coordinate& coord,
		Normal& normal,
		Transform& ROOT,
		Transform& lFootRotY,
		Transform& lFoot,
		Transform& foot0,
		Transform& legTilt,
		Transform& lAnkleRotY,
		Transform& l_ankle,
		Transform& l_knee,
		Shape& LegSeg,
		Transform& torso1,
		Transform& torso0,
		Transform& l_eyestem_base,
		Shape& HoppyEyeStemSed,
		ImageTexture& robotTexture,
		Transform& l_eyestem_joint1,
		Transform& l_eyestem_joint2,
		Transform& l_eyeball,
		Shape& eye_ball,
		Transform& r_eyestem_base,
		Transform& r_eyestem_joint1,
		Transform& r_eyestem_joint2,
		Transform& r_eyeball,
		Transform& l_arm,
		Shape& hoppy_arm,
		Transform& l_hand,
		M_Vec3f& Coord,
		M_Vec3f& Norm,
		M_Int& Indices,
		int& landStrips,
		int& landEdgePntCnt,
		float& landSquareSize,
		float& oneDivByLandSquareSize,
		float& halfLSS,
		int& NumVertices,
		float& LandCXZ,
		float& LandTrans,
		Vec3f& Pos,

		Vec3f& ActualPos,
		Vec3f& LastRisingPos,
		Vec3f& JumpStartPos,
		Vec3f& TargetLandingPos,
		Vec3f& FutureLastRisingPos,
		int& HoppyStillPhase,
		int& HoppyRisingPhase,
		int& HoppyAirbornePhase,
		int& HoppyLandingPhase,
		int& Phase,
		bool& Startflag,
		double& StrtTime,
		float& gForce,
		float& gTime,
		bool& Move,
		float& JumpStartTime,
		float& TargetLandingTime,
		float& PrevTime,
		float& Yangle,
		float& ActualYangle,
		float& FinalYVelocity,
		float& FinalZVelocity,
		float& hya,
		float& CorrectHya,
		float& LandingCorrectHya,
		float& OverShootS,
		float& HopEndOverShootS,
		float& LandingAcceleration,
		float& ySPointOfTakeOff,
		float& ySPointOfLand,
		float& TempDist,
		float& FootPosy,
		float& TargetLandingYDiff,
		float& RisingPeriod,
		float& AirbornePeriod,
		float& TurnSpeed,
		float& fOneDivCirTwoPI,
		float& EyeWaveCycle,
		float& L_FwheelAng,
		float& R_FwheelAng,
		float& BwheelAng,
		float& JumpStartFootAngleX,
		float& JumpStartFootAngleZ,
		float& FootAngleX,
		float& FootAngleZ,
		float& FutureFootAngleXDiff,
		float& FutureFootAngleZDiff,
		float& yVelCorection,
		float& ToeLen,
		float& Speed,
		float& LegLength,
		float& FlatFinalYVelocity,
		float& abit,
		float& FinalTurnAngle,
		float& InitHopChy,
		float& LandingVelocity,

		Vec3f& TargetLandingFootPos
	):
	hoppyVP(hoppyVP),
	geometry(geometry),
	coord(coord),
	normal(normal),
	ROOT(ROOT),
	lFootRotY(lFootRotY),
	lFoot(lFoot),
	foot0(foot0),
	legTilt(legTilt),
	lAnkleRotY(lAnkleRotY),
	l_ankle(l_ankle),
	l_knee(l_knee),
	LegSeg(LegSeg),
	torso1(torso1),
	torso0(torso0),
	l_eyestem_base(l_eyestem_base),
	HoppyEyeStemSed(HoppyEyeStemSed),
	robotTexture(robotTexture),
	l_eyestem_joint1(l_eyestem_joint1),
	l_eyestem_joint2(l_eyestem_joint2),
	l_eyeball(l_eyeball),
	eye_ball(eye_ball),
	r_eyestem_base(r_eyestem_base),
	r_eyestem_joint1(r_eyestem_joint1),
	r_eyestem_joint2(r_eyestem_joint2),
	r_eyeball(r_eyeball),
	l_arm(l_arm),
	hoppy_arm(hoppy_arm),
	l_hand(l_hand),
	Coord(Coord),
	Norm(Norm),
	Indices(Indices),
	landStrips(landStrips),
	landEdgePntCnt(landEdgePntCnt),
	landSquareSize(landSquareSize),
	oneDivByLandSquareSize(oneDivByLandSquareSize),
	halfLSS(halfLSS),
	NumVertices(NumVertices),
	LandCXZ(LandCXZ),
	LandTrans(LandTrans),
	Pos(Pos),

	ActualPos(ActualPos),
	LastRisingPos(LastRisingPos),
	JumpStartPos(JumpStartPos),
	TargetLandingPos(TargetLandingPos),
	FutureLastRisingPos(FutureLastRisingPos),
	HoppyStillPhase(HoppyStillPhase),
	HoppyRisingPhase(HoppyRisingPhase),
	HoppyAirbornePhase(HoppyAirbornePhase),
	HoppyLandingPhase(HoppyLandingPhase),
	Phase(Phase),
	Startflag(Startflag),
	StrtTime(StrtTime),
	gForce(gForce),
	gTime(gTime),
	Move(Move),
	JumpStartTime(JumpStartTime),
	TargetLandingTime(TargetLandingTime),
	PrevTime(PrevTime),
	Yangle(Yangle),
	ActualYangle(ActualYangle),
	FinalYVelocity(FinalYVelocity),
	FinalZVelocity(FinalZVelocity),
	hya(hya),
	CorrectHya(CorrectHya),
	LandingCorrectHya(LandingCorrectHya),
	OverShootS(OverShootS),
	HopEndOverShootS(HopEndOverShootS),
	LandingAcceleration(LandingAcceleration),
	ySPointOfTakeOff(ySPointOfTakeOff),
	ySPointOfLand(ySPointOfLand),
	TempDist(TempDist),
	FootPosy(FootPosy),
	TargetLandingYDiff(TargetLandingYDiff),
	RisingPeriod(RisingPeriod),
	AirbornePeriod(AirbornePeriod),
	TurnSpeed(TurnSpeed),
	fOneDivCirTwoPI(fOneDivCirTwoPI),
	EyeWaveCycle(EyeWaveCycle),
	L_FwheelAng(L_FwheelAng),
	R_FwheelAng(R_FwheelAng),
	BwheelAng(BwheelAng),
	JumpStartFootAngleX(JumpStartFootAngleX),
	JumpStartFootAngleZ(JumpStartFootAngleZ),
	FootAngleX(FootAngleX),
	FootAngleZ(FootAngleZ),
	FutureFootAngleXDiff(FutureFootAngleXDiff),
	FutureFootAngleZDiff(FutureFootAngleZDiff),
	yVelCorection(yVelCorection),
	ToeLen(ToeLen),
	Speed(Speed),
	LegLength(LegLength),
	FlatFinalYVelocity(FlatFinalYVelocity),
	abit(abit),
	FinalTurnAngle(FinalTurnAngle),
	InitHopChy(InitHopChy),
	LandingVelocity(LandingVelocity),


	TargetLandingFootPos(TargetLandingFootPos)


{
	initialize();
}

void initialize(){//equivelent to initialize in vrml

	LandTrans = LandCXZ * .5;
	landEdgePntCnt = landStrips + 1;
	landSquareSize = LandCXZ / landStrips;
	halfLSS = landSquareSize * .5;
	oneDivByLandSquareSize = 1 / landSquareSize;

	GenFlat(landSquareSize, 0, 0, 1, 1);

	tug(0, 2, -32, 8);
	tug(0, 2, -25, 10);
	tug(10, 2, -20, 14);

	tug(-10, 2, -20, 13);
	tug(-8, 1.8, -30, 10);
	tug(-36, 1.1, -36, 8);
	tug(-34, .9, -42, 6);
	tug(-29, .9, -40, 6);

	tug(20, 2, 21, 11);
	tug(25, 1, 18, 8);
	tug(18, .8, 25, 9);

	tug(37, 1.3, 38, 9);
	tug(34, .9, 43, 6);
	tug(30, 1.3, 41, 7);
	tug(41, 1.7, 30, 7);
	tug(43, 1.1, 24, 5.5);

	tug(0, 3, -10, 20);
	tug(8, 3, 5, 18);
	tug(15, 2, -7, 15);
	tug(25, 4, -1, 15);

	CreateLandNormals();

	coord.point = Coord;
	normal.vector = Norm;

	geometry.coordIndex = Indices;

	hoppyInitialize();
}

void onFrame(float v){//simulate Anim's onFrame (can add break point here and single step to check a point in time for the animation)

	if (Startflag == false) {
		StrtTime = getTime();
		Startflag = true;
	}
	gTime = getTime() - StrtTime;
	//gTime = gTime * .5;

	if (Phase == HoppyRisingPhase) {
		HoppyRisingSub();
	}
	else if (Phase == HoppyAirbornePhase) {
		HoppyAirborneSub();
	}
	else if (Phase == HoppyLandingPhase) {
		HoppyLandingSub();
	}
	else if (Phase == HoppyStillPhase) {
		HoppyStillSub();
	}

	Rotation rot = Rotation(1, 0, 0, -.5) * Rotation(0, 1, 0, gTime * .25);
	hoppyVP.orientation = rot;

	hoppyVP.position = Vec3f(ActualPos.x, getLandHeight(ActualPos.x, ActualPos.z) + .5, ActualPos.z) + rot * Vec3f(0, 0, 4);

}
void GenIndices() {

	int NumIndices = (landEdgePntCnt - 1) * (landEdgePntCnt - 1) * 2 * 4;
	Indices.length = NumIndices;
	int b = 0;
	int end = NumIndices;
	for (int m = 0; b < end; m += landEdgePntCnt) {
		for (int j = 0; j < landEdgePntCnt - 1; j++) {
			Indices[b++] = m + j + 1;
			Indices[b++] = m + j;
			Indices[b++] = m + j + landEdgePntCnt;
			Indices[b++] = -1;

			Indices[b++] = m + j + 1;
			Indices[b++] = m + j + landEdgePntCnt;
			Indices[b++] = m + j + landEdgePntCnt + 1;
			Indices[b++] = -1;
		}
	}

}

void GenFlat(float SquareLength, float uOffset, float vOffset, float uScale, float vScale) {
	NumVertices = landEdgePntCnt * landEdgePntCnt;
	Coord.length = NumVertices;
	Norm.length = NumVertices;

	for (int b = 0; b < landEdgePntCnt; b++) {
		float v = (1 - 1 / (landEdgePntCnt - 1) * b) * vScale + vOffset;
		for (int s = 0; s < landEdgePntCnt; s++) {
			Coord[b * landEdgePntCnt + s] = Vec3f(SquareLength * s - LandTrans, 0, SquareLength * b - LandTrans);
			Norm[b * landEdgePntCnt + s] = Vec3f(0, 1, 0);
		}
	}
	GenIndices();
}

void tug(float centerX, float Height, float centerZ, float rad) {

	for (int i = 0; i < NumVertices; i++) {
		float ADJ = fabs(centerX - Coord[i].x);
		float OPP = fabs(centerZ - Coord[i].z);
		float HYP = sqrt(ADJ * ADJ + OPP * OPP);
		if (rad > HYP) {
			Coord[i].y += (1 + cos(HYP / rad * PI)) / 2 * Height;
		}
	}
}

Vec3f CalculateVectorNormal(float fVert1x, float fVert1y, float fVert1z, float fVert2x, float fVert2y, float fVert2z, float fVert3x, float fVert3y, float fVert3z) {
	float Qx = fVert2x - fVert1x;
	float Qy = fVert2y - fVert1y;
	float Qz = fVert2z - fVert1z;
	float Px = fVert3x - fVert1x;
	float Py = fVert3y - fVert1y;
	float Pz = fVert3z - fVert1z;

	Vec3f fNormal = Vec3f(Py * Qz - Pz * Qy, Pz * Qx - Px * Qz, Px * Qy - Py * Qx);

	fNormal = fNormal.normalize();

	return -fNormal;
}

void CreateLandNormals() {

	CalculateVectorNormal(-1, 0, 1, 1, 0, 1, 0, 0, -1);
	for (int r = 1; r < landEdgePntCnt - 1; r++) {
		for (int s = 1; s < landEdgePntCnt - 1; s++) {
			int p1 = (r - 1) * landEdgePntCnt + s;
			int p2 = (r + 1) * landEdgePntCnt + s;
			int p3 = r * landEdgePntCnt + s - 1;
			int p4 = r * landEdgePntCnt + s + 1;
			Norm[r * landEdgePntCnt + s] = CalculateVectorNormal(Coord[p1].x, Coord[p1].y, Coord[p1].z, Coord[p2].x, Coord[p2].y, Coord[p2].z, Coord[p1].x + Coord[p4].x - Coord[p3].x, Coord[p1].y + Coord[p4].y - Coord[p3].y, Coord[p1].z + Coord[p4].z - Coord[p3].z);
		}
	}
}



float getLandHeight(float x, float z) {

	float a = bridgeGetLandHeight(getLandHeightFunc->startCodePtr, x, z);
	return a;
	



	float modX = (x + LandTrans) / landSquareSize;
	float modZ = (z + LandTrans) / landSquareSize;
	float SqX = floor(modX);
	float SqZ = floor(modZ);
	modX = (modX - SqX) * landSquareSize;
	modZ = (modZ - SqZ) * landSquareSize;
	int lx = SqX;
	int lz = SqZ * landEdgePntCnt;
	int lz2 = lz + landEdgePntCnt;

	float by1 = 0;
	float by2 = 0;

	float bl = Coord[lz + lx].y;
	float br = Coord[lz + lx + 1].y;
	float tl = Coord[lz2 + lx].y;
	float tr = Coord[lz2 + lx + 1].y;

	float tx = modX - halfLSS;
	float tz = modZ - halfLSS;

	float angle = .25 * PI;
	float newZ = tz * cos(angle) - tx * sin(angle);
	tx = tz * sin(angle) + tx * cos(angle);
	tz = newZ;

	if (tx < 0) {
		tr = br + (tl - bl);
	}
	else {
		bl = tl + (br - tr);
	}
	by1 = bl + (tl - bl) * (modZ * (oneDivByLandSquareSize));
	by2 = br + (tr - br) * (modZ * (oneDivByLandSquareSize));

	return by1 + (by2 - by1) * (modX * (oneDivByLandSquareSize));
}

void HoppyStillSub() {

	HoppyCtrl();
	if (Move) {
		PrevTime = gTime;
		JumpStartTime = gTime;
		lFootRotY.rotation = Rotation(0, 0, 1, 0);
		Phase = HoppyRisingPhase;
	}
	float Time = gTime - JumpStartTime;

	float Chx = 0;
	float Chy = InitHopChy;
	float Chz = 0;

	float Chyzdis = sqrt(Chy * Chy + Chz * Chz);
	float Chxydis = sqrt(pow(sqrt(Chx * Chx + Chy * Chy), 2) + Chz * Chz);

	float ChxyAng = acos(Chx / Chxydis);
	float Mky = sqrt(LegLength * LegLength - Chxydis / 2 * Chxydis / 2);
	float MazyAng = asin(Mky / LegLength) + ChxyAng - PI / 2;
	float zL_Ankle = MazyAng;
	float MkzyAng = (-2 * acos(Chxydis / 2 / LegLength));


	ActualYangle = Yangle;

}

void hoppyInitialize() {

	JumpStartTime = gTime;

	Pos = Vec3f(0, FootPosy + InitHopChy, 0);
	ActualPos = Pos;

	LastRisingPos = Pos;

	JumpStartPos = Pos;

	ActualYangle = Yangle + FinalTurnAngle;

	AirbornePeriod = 1;
	FootAngleX = 0;
	FootAngleZ = 0;
	JumpStartFootAngleX = 0;
	JumpStartFootAngleZ = 0;
	FutureFootAngleXDiff = 0;
	FutureFootAngleZDiff = 0;
}

void HoppyRisingSub() {

	float Time = gTime - JumpStartTime;
	float hza = FinalZVelocity / RisingPeriod;
	if (Time >= RisingPeriod) {

		LastRisingPos = FutureLastRisingPos;
		Pos = FutureLastRisingPos;
		PrevTime = JumpStartTime + RisingPeriod;
		Phase = HoppyAirbornePhase;
		lAnkleRotY.rotation = Rotation(0, 0, 1, 0);
		torso1.rotation = Rotation(0, 0, 1, 0);
		HoppyAirborneSub();
		return;

	}
	float VwithAddedVelocity = hya * Time;
	float SwithAddedVelocity = hya / 2 * pow(Time, 2);
	float CorrectS = 0;
	float CorrectV = 0;
	if (Time <= RisingPeriod * .5) {
		CorrectS = CorrectHya / 2 * pow(Time, 2);
		CorrectV = CorrectHya * Time;
	}
	else {
		CorrectS = -CorrectHya / 2 * pow(RisingPeriod - Time, 2) + OverShootS;
		CorrectV = CorrectHya * (RisingPeriod - Time);
	}

	float s = SwithAddedVelocity + CorrectS;
	Pos.y = JumpStartPos.y + s;
	float v = VwithAddedVelocity + CorrectV;
	float Chy = InitHopChy + s;

	float HopPeriod = AirbornePeriod + RisingPeriod * 2;

	TurnSpeed = sqrt(Speed * Speed + FinalZVelocity * FinalZVelocity);
	float sda = (TurnSpeed - Speed) / RisingPeriod;
	float SlowDownDis = (sda / 2) * (RisingPeriod * RisingPeriod);

	float a = gTime - JumpStartTime;

	float sv = sda * Time;
	float zv = hza * Time;
	float Chz = (hza / 2) * (Time * Time);
	float Chx = Time * Speed;

	float Chyzdis = sqrt(Chy * Chy + Chz * Chz);
	float Chxydis = sqrt(pow(sqrt(Chx * Chx + Chy * Chy), 2) + Chz * Chz);

	float ChxyAng = acos(Chx / Chxydis);
	float Mky = sqrt(LegLength * LegLength - Chxydis / 2 * Chxydis / 2);
	float MazyAng = asin(Mky / LegLength) + ChxyAng - PI / 2;
	float zL_Ankle = MazyAng;
	float MkzyAng = (-2 * acos(Chxydis / 2 / LegLength));

	float Mul = .5 * (VwithAddedVelocity / FinalYVelocity);

	Rotation eyeRot = Rotation(.908226, -.386624, .160145, .6 + .5 * (.855778 - .6) + Mul * (.855778 - .6));
	l_eyestem_base.rotation = eyeRot;
	eyeRot.y = -eyeRot.y;
	eyeRot.z = -eyeRot.z;
	r_eyestem_base.rotation = eyeRot;

	eyeRot = Rotation(1, .5, 0, .1 + .5 * (.4 - .1) + Mul * (.4 - .1));
	l_eyestem_joint1.rotation = eyeRot;
	l_eyestem_joint2.rotation = eyeRot;
	eyeRot.y = -eyeRot.y;
	eyeRot.z = -eyeRot.z;
	r_eyestem_joint1.rotation = eyeRot;
	r_eyestem_joint2.rotation = eyeRot;

	l_knee.rotation = Rotation(-1, 0, 0, MkzyAng);
	l_knee.translation = Vec3f(0, LegLength, 0);

	l_ankle.rotation = Rotation(-1, 0, 0, zL_Ankle);

	foot0.rotation = Rotation(1, 0, 0, FootAngleX) * Rotation(0, 0, 1, FootAngleZ);

	foot0.translation = Vec3f(0, 0, -Chx);
	l_ankle.translation = Vec3f(0, 0, -Chx);


	ActualYangle = Yangle + FinalTurnAngle * (Time / (RisingPeriod + AirbornePeriod));

	torso0.rotation = Rotation(0, 1, 0, FinalTurnAngle * (Time / (RisingPeriod + AirbornePeriod))) * Rotation(0, 0, 1, -asin(Chz / Chyzdis));
	torso0.translation = Vec3f(0, Chyzdis, 0);


	legTilt.center = Vec3f(0, 0, 0);
	Rotation r = Rotation(0, 0, 1, asin(Chz / Chyzdis));
	legTilt.rotation = r;
	torso1.rotation = r;

	Vec3f vec = Vec3f(0, s + InitHopChy - Chy + abit, 0);
	lFootRotY.translation = vec;
	legTilt.translation = vec;
	torso1.translation = vec;

	Pos.x = JumpStartPos.x + Time * Speed * sin(Yangle);
	Pos.z = JumpStartPos.z + Time * Speed * cos(Yangle);

	ActualPos.x = Chz;
	ActualPos.z = Time * Speed;
	float newX = -(ActualPos.x * cos(Yangle) - ActualPos.z * sin(Yangle));
	float newZ = (ActualPos.x * sin(Yangle) + ActualPos.z * cos(Yangle));
	ActualPos.x = newX;
	ActualPos.z = newZ;
	ActualPos.x += JumpStartPos.x;
	ActualPos.z += JumpStartPos.z;





	ActualPos.y = Pos.y;

	ROOT.rotation = Rotation(0, 1, 0, Yangle);
	ROOT.translation = Vec3f(Pos.x, FootPosy, Pos.z);

	PrevTime = gTime;



}

void HoppyAirborneSub() {

	float Time = gTime - JumpStartTime;

	float v = FinalYVelocity - gForce * (Time - RisingPeriod);
	float s = FinalYVelocity * (Time - RisingPeriod) - (gForce / 2) * powf(Time - RisingPeriod, 2) + ySPointOfTakeOff;
	Pos.y = JumpStartPos.y + s;

	float Chy = InitHopChy + ySPointOfTakeOff;

	float sda = (TurnSpeed - Speed) / RisingPeriod;
	float SlowDownDis = (sda / 2) * (RisingPeriod * RisingPeriod);
	float HopPeriod = AirbornePeriod + RisingPeriod * 2;

	float RTL_Time = RisingPeriod + AirbornePeriod;
	float FlyingAnkleForward = 0;
	if (Time < RTL_Time) {
		FlyingAnkleForward = (RisingPeriod * Speed + RisingPeriod * TurnSpeed - SlowDownDis) / (RTL_Time - RisingPeriod) * (Time - RisingPeriod);
	}
	else {
		FlyingAnkleForward = RisingPeriod * Speed + RisingPeriod * TurnSpeed - SlowDownDis;
	}
	float Chx = RisingPeriod * Speed - FlyingAnkleForward;

	if (gTime >= TargetLandingTime) {
		PrevTime = TargetLandingTime;
		Pos = TargetLandingPos;
		FootAngleX = JumpStartFootAngleX + FutureFootAngleXDiff;
		FootAngleZ = JumpStartFootAngleZ + FutureFootAngleZDiff;
		Phase = HoppyLandingPhase;
		torso1.translation = Vec3f(0, 0, 0);
		HoppyLandingSub();

		return;
	}
	FootAngleX = JumpStartFootAngleX + FutureFootAngleXDiff / AirbornePeriod * (Time - RisingPeriod);
	FootAngleZ = JumpStartFootAngleZ + FutureFootAngleZDiff / AirbornePeriod * (Time - RisingPeriod);

	float hza = FinalZVelocity / RisingPeriod;
	TurnSpeed = sqrt(Speed * Speed + FinalZVelocity * FinalZVelocity);

	float sv = sda * Time;
	float zv = FinalZVelocity;

	float Chz = (hza / 2) * (RisingPeriod * RisingPeriod) - (hza / 2) * (RisingPeriod * RisingPeriod) / AirbornePeriod * (Time - RisingPeriod);

	float Chyzdis = sqrt(Chy * Chy + Chz * Chz);
	float Chxydis = sqrt(pow(sqrt(Chx * Chx + Chy * Chy), 2) + Chz * Chz);

	float ChxyAng = acos(Chx / Chxydis);
	float Mky = sqrt(LegLength * LegLength - Chxydis / 2 * Chxydis / 2);
	float MazyAng = asin(Mky / LegLength) + ChxyAng - PI / 2;
	float zL_Ankle = MazyAng;
	float MkzyAng = (-2 * acos(Chxydis / 2 / LegLength));

	float Mul = 3 * (Time - RisingPeriod);
	if (Mul > 1) {
		Mul = 1;
	}
	Rotation eyeRot = Rotation(.908226, -.386624, .160145, .855778 - Mul * (.855778 - .6));
	l_eyestem_base.rotation = eyeRot;
	eyeRot.y = -eyeRot.y;
	eyeRot.z = -eyeRot.z;
	r_eyestem_base.rotation = eyeRot;

	eyeRot = Rotation(1, .5, 0, .4 - Mul * (.4 - .1));
	l_eyestem_joint1.rotation = eyeRot;
	l_eyestem_joint2.rotation = eyeRot;
	eyeRot.y = -eyeRot.y;
	eyeRot.z = -eyeRot.z;
	r_eyestem_joint1.rotation = eyeRot;
	r_eyestem_joint2.rotation = eyeRot;

	l_knee.rotation = Rotation(-1, 0, 0, MkzyAng);
	l_knee.translation = Vec3f(0, LegLength, 0);

	l_ankle.rotation = Rotation(-1, 0, 0, zL_Ankle);

	foot0.rotation = Rotation(1, 0, 0, FootAngleX) * Rotation(0, 0, 1, FootAngleZ);

	foot0.translation = Vec3f(0, 0, -Chx);
	l_ankle.translation = Vec3f(0, 0, -Chx);

	ActualYangle = Yangle + FinalTurnAngle * (Time / (RisingPeriod + AirbornePeriod));

	torso0.rotation = Rotation(0, 1, 0, FinalTurnAngle * (Time / (RisingPeriod + AirbornePeriod)));

	Rotation ya = Rotation(0, 1, 0, FinalTurnAngle - FinalTurnAngle * (1 - (Time - RisingPeriod) / AirbornePeriod));
	lFootRotY.rotation = ya;
	lAnkleRotY.rotation = ya;

	legTilt.center = Vec3f(0, Chy, 0);
	legTilt.rotation = Rotation(0, 0, 1, asin(Chz / Chyzdis));

	torso0.translation = Vec3f(0, Chy, 0);

	Vec3f vec = Vec3f(0, s + InitHopChy - Chy + abit, 0);
	legTilt.translation = vec;
	torso1.translation = vec;
	vec.x = Chz;
	lFootRotY.translation = vec;


	Pos.z += (gTime - PrevTime) * (TurnSpeed)* cos(Yangle + FinalTurnAngle);
	Pos.x += (gTime - PrevTime) * (TurnSpeed)* sin(Yangle + FinalTurnAngle);

	ActualPos = Pos;
	ROOT.rotation = Rotation(0, 1, 0, Yangle);
	ROOT.translation = Vec3f(Pos.x, JumpStartPos.y - InitHopChy, Pos.z);

	PrevTime = gTime;

}

void TargetLandingSub() {

	bridgeTargetLandingSub(TargetLandingSubFunc->startCodePtr);
	return;

	
	JumpStartFootAngleX = JumpStartFootAngleX + FutureFootAngleXDiff;
	JumpStartFootAngleZ = JumpStartFootAngleZ + FutureFootAngleZDiff;

	AirbornePeriod = FlatFinalYVelocity / gForce * 2;
	TargetLandingTime = JumpStartTime + AirbornePeriod + RisingPeriod;

	float hza = FinalZVelocity / RisingPeriod;
	TurnSpeed = sqrt(Speed * Speed + FinalZVelocity * FinalZVelocity);
	float sda = (TurnSpeed - Speed) / RisingPeriod;

	float z = (hza / 2) * (RisingPeriod * RisingPeriod);
	float x = RisingPeriod * Speed;
	float newX = -(z * cos(Yangle) - x * sin(Yangle));
	float newZ = (z * sin(Yangle) + x * cos(Yangle));

	FutureLastRisingPos.x = newX + JumpStartPos.x;
	FutureLastRisingPos.z = newZ + JumpStartPos.z;

	TargetLandingPos.x = FutureLastRisingPos.x;
	TargetLandingPos.z = FutureLastRisingPos.z;

	TargetLandingPos.z += AirbornePeriod * TurnSpeed * cos(Yangle + FinalTurnAngle);
	TargetLandingPos.x += AirbornePeriod * TurnSpeed * sin(Yangle + FinalTurnAngle);

	Vec3f TargetLandingFootPos = Vec3f(TargetLandingPos.x + (RisingPeriod * TurnSpeed - (sda / 2) * pow(RisingPeriod, 2)) * sin(Yangle + FinalTurnAngle), 0, TargetLandingPos.z + (RisingPeriod * TurnSpeed - (sda / 2) * pow(RisingPeriod, 2)) * cos(Yangle + FinalTurnAngle));
	

	TargetLandingFootPos.y = getLandHeight(TargetLandingFootPos.x, TargetLandingFootPos.z);

	TargetLandingYDiff = TargetLandingFootPos.y + InitHopChy - Pos.y;

	FinalYVelocity = FlatFinalYVelocity + TargetLandingYDiff * yVelCorection;
	hya = FinalYVelocity / RisingPeriod;
	float FlatHya = FlatFinalYVelocity / RisingPeriod;
	ySPointOfTakeOff = FlatHya / 2 * powf(RisingPeriod, 2);
	OverShootS = ySPointOfTakeOff - hya / 2 * powf(RisingPeriod, 2);
	CorrectHya = OverShootS / powf(RisingPeriod, 2) * 4;
	LandingVelocity = FinalYVelocity - gForce * AirbornePeriod;
	LandingAcceleration = LandingVelocity / RisingPeriod;
	TempDist = LandingAcceleration / 2 * powf(RisingPeriod, 2);
	ySPointOfLand = ySPointOfTakeOff + TargetLandingYDiff;
	HopEndOverShootS = TargetLandingYDiff - (TempDist + ySPointOfLand);
	LandingCorrectHya = -HopEndOverShootS / powf(RisingPeriod, 2) * 4;

	FutureLastRisingPos.y = JumpStartPos.y + ySPointOfTakeOff;

	FootPosy = JumpStartPos.y - InitHopChy;
	TargetLandingPos.y = TargetLandingFootPos.y + ySPointOfLand + InitHopChy;




	float ZWBP = ToeLen * sin(PI / 18 * 4);

	Vec3f lBase = Vec3f(ToeLen * cos(PI / 18 * 4 - Yangle - FinalTurnAngle), 0, ToeLen * sin(PI / 18 * 4 - Yangle - FinalTurnAngle));

	Vec3f rBase = Vec3f(ToeLen * cos(-PI / 18 * 4 - Yangle - FinalTurnAngle), 0, ToeLen * sin(-PI / 18 * 4 - Yangle - FinalTurnAngle));

	Vec3f fBase = Vec3f(ToeLen * cos(-Yangle - FinalTurnAngle), 0, ToeLen * sin(-Yangle - FinalTurnAngle));

	Vec3f bBase = Vec3f(ToeLen * cos(PI - Yangle - FinalTurnAngle), 0, ToeLen * sin(PI - Yangle - FinalTurnAngle));

	lBase.y = getLandHeight(Pos.x + lBase.x, Pos.z + lBase.z);
	rBase.y = getLandHeight(Pos.x + rBase.x, Pos.z + rBase.z);
	fBase.y = getLandHeight(Pos.x + fBase.x, Pos.z + fBase.z);
	bBase.y = getLandHeight(Pos.x + bBase.x, Pos.z + bBase.z);

	float lrMidPointY = (lBase.y - rBase.y) / 2;
	float FutureFootAngleX = -asin(lrMidPointY / ZWBP);

	float fbMidPointY = (fBase.y - bBase.y) / 2;
	float FutureFootAngleZ = asin(fbMidPointY / ToeLen);

	FutureFootAngleXDiff = FutureFootAngleX - FootAngleX;
	FutureFootAngleZDiff = FutureFootAngleZ - FootAngleZ;

}

void HoppyCtrl() {
	Move = true;
	FinalZVelocity = -Speed * (sin(FinalTurnAngle) / cos(FinalTurnAngle));
	RisingPeriod = .233333;
	FinalYVelocity = Speed * 2;
	if (Speed <= 20) {
		FinalYVelocity = 40;
	}
	TargetLandingSub();
}

void HoppyLandingSub() {

	float HopPeriod = AirbornePeriod + RisingPeriod * 2;

	float hza = FinalZVelocity / RisingPeriod;
	TurnSpeed = sqrt(Speed * Speed + FinalZVelocity * FinalZVelocity);
	float sda = (TurnSpeed - Speed) / RisingPeriod;
	float SlowDownDis = (sda / 2) * (RisingPeriod * RisingPeriod);

	float a = gTime - JumpStartTime;

	if (a >= HopPeriod) {
		JumpStartTime += HopPeriod;
		PrevTime = JumpStartTime;
		a -= HopPeriod;

		Pos.x = LastRisingPos.x;
		Pos.z = LastRisingPos.z;

		Pos.z += AirbornePeriod * TurnSpeed * cos(Yangle + FinalTurnAngle);
		Pos.x += AirbornePeriod * TurnSpeed * sin(Yangle + FinalTurnAngle);

		Pos.z += (RisingPeriod * TurnSpeed - (sda / 2) * pow(RisingPeriod, 2)) * cos(Yangle + FinalTurnAngle);
		Pos.x += (RisingPeriod * TurnSpeed - (sda / 2) * pow(RisingPeriod, 2)) * sin(Yangle + FinalTurnAngle);

		Yangle += FinalTurnAngle;

		JumpStartPos = Pos;

		HoppyCtrl();
		if (Move) {
			Phase = HoppyRisingPhase;
			lFootRotY.rotation = Rotation(0, 0, 1, 0);
			lAnkleRotY.rotation = Rotation(0, 0, 1, 0);
			HoppyRisingSub();
			return;
		}
		else {
			Phase = HoppyStillPhase;
			HoppyStillSub();
			return;
		}
	}

	float Time = gTime - JumpStartTime;
	float now = Time / HopPeriod;

	float VwithAddedVelocity = LandingAcceleration * (RisingPeriod * 2 + AirbornePeriod - Time);
	float SwithAddedVelocity = -LandingAcceleration / 2 * pow(RisingPeriod * 2 + AirbornePeriod - Time, 2) + TempDist + ySPointOfLand;
	float CorrectS = 0;
	float CorrectV = 0;
	if (Time < RisingPeriod * 1.5 + AirbornePeriod) {
		CorrectV = LandingCorrectHya * (Time - RisingPeriod - AirbornePeriod);
		CorrectS = -LandingCorrectHya / 2 * powf(Time - RisingPeriod - AirbornePeriod, 2);
	}
	else {
		CorrectV = LandingCorrectHya * ((RisingPeriod * 2 + AirbornePeriod) - Time);
		CorrectS = LandingCorrectHya / 2 * pow((RisingPeriod * 2 + AirbornePeriod) - Time, 2) + HopEndOverShootS;
	}
	float v = VwithAddedVelocity + CorrectV;
	float s = SwithAddedVelocity + CorrectS;
	Pos.y = JumpStartPos.y + s;
	float sv = sda * Time;
	float zv = FinalZVelocity;



	float Chy = InitHopChy + s - TargetLandingYDiff;


	float Chz = 0;

	float FlyingAnkleForward = RisingPeriod * Speed + RisingPeriod * TurnSpeed - SlowDownDis;
	float Chx = RisingPeriod * Speed - FlyingAnkleForward + (Time - RisingPeriod - AirbornePeriod) * TurnSpeed - (sda / 2) * pow((Time - RisingPeriod - AirbornePeriod), 2);

	float Chyzdis = sqrt(Chy * Chy + Chz * Chz);
	float Chxydis = sqrt(pow(sqrt(Chx * Chx + Chy * Chy), 2) + Chz * Chz);

	float ChxyAng = acos(Chx / Chxydis);
	float Mky = sqrt(LegLength * LegLength - Chxydis / 2 * Chxydis / 2);
	float MazyAng = asin(Mky / LegLength) + ChxyAng - PI / 2;
	float zL_Ankle = MazyAng;
	float MkzyAng = (-2 * acos(Chxydis / 2 / LegLength));

	float Mul = .5 * (1 - VwithAddedVelocity / LandingVelocity);
	Rotation eyeRot = Rotation(.908226, -.386624, .160145, .6 + Mul * (.855778 - .6));
	l_eyestem_base.rotation = eyeRot;
	eyeRot.y = -eyeRot.y;
	eyeRot.z = -eyeRot.z;
	r_eyestem_base.rotation = eyeRot;

	eyeRot = Rotation(1, .5, 0, .1 + Mul * (.4 - .1));
	l_eyestem_joint1.rotation = eyeRot;
	l_eyestem_joint2.rotation = eyeRot;
	eyeRot.y = -eyeRot.y;
	eyeRot.z = -eyeRot.z;
	r_eyestem_joint1.rotation = eyeRot;
	r_eyestem_joint2.rotation = eyeRot;

	l_knee.rotation = Rotation(-1, 0, 0, MkzyAng);
	l_knee.translation = Vec3f(0, LegLength, 0);

	l_ankle.rotation = Rotation(-1, 0, 0, zL_Ankle);

	foot0.rotation = Rotation(1, 0, 0, FootAngleX) * Rotation(0, 0, 1, FootAngleZ);

	foot0.translation = Vec3f(0, 0, -Chx);
	l_ankle.translation = Vec3f(0, 0, -Chx);

	ActualYangle = Yangle + FinalTurnAngle;

	torso0.rotation = Rotation(0, 1, 0, FinalTurnAngle);

	Rotation r = Rotation(0, 1, 0, FinalTurnAngle);
	lFootRotY.rotation = r;
	lAnkleRotY.rotation = r;

	legTilt.center = Vec3f(0, Chy, 0);
	legTilt.rotation = Rotation(0, 0, 1, asin(Chz / Chyzdis));
	float TurnLeanAngle = asin(Chz / Chyzdis);

	lFootRotY.translation = Vec3f(0, s + InitHopChy - Chy + abit, -Chz);
	legTilt.translation = Vec3f(0, s + InitHopChy - Chy + abit, 0);
	torso0.translation = Vec3f(0, s + InitHopChy + abit, 0);

	Pos.x = LastRisingPos.x;
	Pos.z = LastRisingPos.z;

	Pos.z += AirbornePeriod * TurnSpeed * cos(Yangle + FinalTurnAngle);
	Pos.x += AirbornePeriod * TurnSpeed * sin(Yangle + FinalTurnAngle);

	Pos.z += ((Time - RisingPeriod - AirbornePeriod) * TurnSpeed - (sda / 2) * pow(Time - RisingPeriod - AirbornePeriod, 2)) * cos(Yangle + FinalTurnAngle);
	Pos.x += ((Time - RisingPeriod - AirbornePeriod) * TurnSpeed - (sda / 2) * pow(Time - RisingPeriod - AirbornePeriod, 2)) * sin(Yangle + FinalTurnAngle);

	ActualPos = Pos;

	ROOT.rotation = Rotation(0, 1, 0, Yangle);
	ROOT.translation = Vec3f(Pos.x, JumpStartPos.y - InitHopChy, Pos.z);

	PrevTime = gTime;

}



}; //end ScriptBind class

NodePtr getNodeFromName(const String str);

ScriptBind* scriptBind=0;
void initializeDeveloperScript(){
	scriptBind = new ScriptBind(//new instance of ScriptBind binds the nodes to our script
		*dynamic_cast<Viewpoint*>(getNodeFromName("hoppyVP").p),
		*dynamic_cast<IndexedFaceSet*>(getNodeFromName("geometry").p),
		*dynamic_cast<Coordinate*>(getNodeFromName("coord").p),
		*dynamic_cast<Normal*>(getNodeFromName("normal").p),
		*dynamic_cast<Transform*>(getNodeFromName("ROOT").p),
		*dynamic_cast<Transform*>(getNodeFromName("lFootRotY").p),
		*dynamic_cast<Transform*>(getNodeFromName("lFoot").p),
		*dynamic_cast<Transform*>(getNodeFromName("foot0").p),
		*dynamic_cast<Transform*>(getNodeFromName("legTilt").p),
		*dynamic_cast<Transform*>(getNodeFromName("lAnkleRotY").p),
		*dynamic_cast<Transform*>(getNodeFromName("l_ankle").p),
		*dynamic_cast<Transform*>(getNodeFromName("l_knee").p),
		*dynamic_cast<Shape*>(getNodeFromName("LegSeg").p),
		*dynamic_cast<Transform*>(getNodeFromName("torso1").p),
		*dynamic_cast<Transform*>(getNodeFromName("torso0").p),
		*dynamic_cast<Transform*>(getNodeFromName("l_eyestem_base").p),
		*dynamic_cast<Shape*>(getNodeFromName("HoppyEyeStemSed").p),
		*dynamic_cast<ImageTexture*>(getNodeFromName("robotTexture").p),
		*dynamic_cast<Transform*>(getNodeFromName("l_eyestem_joint1").p),
		*dynamic_cast<Transform*>(getNodeFromName("l_eyestem_joint2").p),
		*dynamic_cast<Transform*>(getNodeFromName("l_eyeball").p),
		*dynamic_cast<Shape*>(getNodeFromName("eye_ball").p),
		*dynamic_cast<Transform*>(getNodeFromName("r_eyestem_base").p),
		*dynamic_cast<Transform*>(getNodeFromName("r_eyestem_joint1").p),
		*dynamic_cast<Transform*>(getNodeFromName("r_eyestem_joint2").p),
		*dynamic_cast<Transform*>(getNodeFromName("r_eyeball").p),
		*dynamic_cast<Transform*>(getNodeFromName("l_arm").p),
		*dynamic_cast<Shape*>(getNodeFromName("hoppy_arm").p),
		*dynamic_cast<Transform*>(getNodeFromName("l_hand").p),
		dynamic_cast<G_M_Vec3f*>(getNodeFromName("Coord").p)->refValue(),
		dynamic_cast<G_M_Vec3f*>(getNodeFromName("Norm").p)->refValue(),
		dynamic_cast<G_M_Int*>(getNodeFromName("Indices").p)->refValue(),
		dynamic_cast<G_S_Int32*>(getNodeFromName("landStrips").p)->refValue(),
		dynamic_cast<G_S_Int32*>(getNodeFromName("landEdgePntCnt").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("landSquareSize").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("oneDivByLandSquareSize").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("halfLSS").p)->refValue(),
		dynamic_cast<G_S_Int32*>(getNodeFromName("NumVertices").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("LandCXZ").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("LandTrans").p)->refValue(),
		dynamic_cast<G_S_Vec3f*>(getNodeFromName("Pos").p)->refValue(),

		dynamic_cast<G_S_Vec3f*>(getNodeFromName("ActualPos").p)->refValue(),
		dynamic_cast<G_S_Vec3f*>(getNodeFromName("LastRisingPos").p)->refValue(),
		dynamic_cast<G_S_Vec3f*>(getNodeFromName("JumpStartPos").p)->refValue(),
		dynamic_cast<G_S_Vec3f*>(getNodeFromName("TargetLandingPos").p)->refValue(),
		dynamic_cast<G_S_Vec3f*>(getNodeFromName("FutureLastRisingPos").p)->refValue(),
		dynamic_cast<G_S_Int32*>(getNodeFromName("HoppyStillPhase").p)->refValue(),
		dynamic_cast<G_S_Int32*>(getNodeFromName("HoppyRisingPhase").p)->refValue(),
		dynamic_cast<G_S_Int32*>(getNodeFromName("HoppyAirbornePhase").p)->refValue(),
		dynamic_cast<G_S_Int32*>(getNodeFromName("HoppyLandingPhase").p)->refValue(),
		dynamic_cast<G_S_Int32*>(getNodeFromName("Phase").p)->refValue(),
		dynamic_cast<G_S_Bool*>(getNodeFromName("Startflag").p)->refValue(),
		dynamic_cast<G_S_Time*>(getNodeFromName("StrtTime").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("gForce").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("gTime").p)->refValue(),
		dynamic_cast<G_S_Bool*>(getNodeFromName("Move").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("JumpStartTime").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("TargetLandingTime").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("PrevTime").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("Yangle").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("ActualYangle").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("FinalYVelocity").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("FinalZVelocity").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("hya").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("CorrectHya").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("LandingCorrectHya").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("OverShootS").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("HopEndOverShootS").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("LandingAcceleration").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("ySPointOfTakeOff").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("ySPointOfLand").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("TempDist").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("FootPosy").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("TargetLandingYDiff").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("RisingPeriod").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("AirbornePeriod").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("TurnSpeed").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("fOneDivCirTwoPI").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("EyeWaveCycle").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("L_FwheelAng").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("R_FwheelAng").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("BwheelAng").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("JumpStartFootAngleX").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("JumpStartFootAngleZ").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("FootAngleX").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("FootAngleZ").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("FutureFootAngleXDiff").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("FutureFootAngleZDiff").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("yVelCorection").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("ToeLen").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("Speed").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("LegLength").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("FlatFinalYVelocity").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("abit").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("FinalTurnAngle").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("InitHopChy").p)->refValue(),
		dynamic_cast<G_S_Float*>(getNodeFromName("LandingVelocity").p)->refValue(),

		dynamic_cast<G_S_Vec3f*>(getNodeFromName("TargetLandingFootPos").p)->refValue()
	);

	int len = g_scene->sceneTreeList.length;
	for (int k = 0; k < len; k++) {
		Function* function = dynamic_cast<Function*>(g_scene->sceneTreeList[k].node.p);
		if (function && function->functionName == "getLandHeight") {
			scriptBind->getLandHeightFunc = function;
		}
		if (function && function->functionName == "TargetLandingSub") {
			scriptBind->TargetLandingSubFunc = function;
		}
	}


}
void scriptBindAnimation(){
	float period = 1;
	if (scriptBind) {
		scriptBind->onFrame(fmodf(g_time / period, period)); // create slider from period and pass as value
	}
}