/* Seamless3d

Copyright (C) 2001-2013 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Create_a_New_Seamless_File;
extern const char* Complete;

#define NARATION 1

void InputEvent::preLimbAnimDemo(){
	g_robotDemo->fileName="animated-limb";
	g_robotDemo->function=InputEvent::limbAnimDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::limbAnimDemo(){

	const int seamless = 1;
	const int l_shoulder = 3;
	const int l_elbow = 4;
	const int l_wrist = 5;

	InputEvent* array0[]={
		new Section("Create a new seamless file"),
//#if NARATION
//	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\Nurbs Stitched Head Tutorial\\create-new-file.wav"),
//#endif
//
//new DragViewRot(.99982,.013795,-.013001,.063678),
//new ClickButton(buildNurbsLatheForSelPart),
//
//new AddCtrlPnt(0,0),
//new AddCtrlPnt(.078125,-.221875),
//new AddCtrlPnt(.371875,-.14375),
//new AddCtrlPnt(.50625,.04375),
//new AddCtrlPnt(.38125,.23125),
//new AddCtrlPnt(.1375,.340625),
//new ToggleField("done"),
//
//new ClickButton(openGridControl),
//
//new ToggleField("show"),
//new MoveToExitWindow(),
//new Click(),
//
//
//new ClickButton(convertToPatch),
//
//new IncFieldX("control_staves", 5),
//new ToggleField("done"),
//new TugCP(70,.530633,.037781),
//new ClickButton(extrudePatch),
//
//new IncFieldX("distance",54),
//new IncFieldX("insertions"),
//new IncFieldX("insertions"),
//new ToggleField("spiderWebCenter"),
//new ToggleField("done"),
//new DragViewRot(.998318,-.054811,.018911,.927998,-1.584375,.103125),
//
//
//new ClickButton(insertControlPoint),
//
//new SelNurbsLine(276,277,.901704),
//new ToggleField("done"),
//new DragViewRot(.603321,-.796824,.032776,1.952668,-.529024,-.277214),
//new TugCP(96,-.517919,-.27244),
//new TugCP(98,-.397276,-.403361),
//new DragViewRot(.338842,-.932924,-.121812,1.263294,-.397276,-.403361),
//new TugCP(272,-.023685,-.120512),
//new TugCP(294,.019709,-.188565),
//new TugCP(316,.060561,-.259828),
//new DragViewRot(.701513,-.49671,-.511037,.528121,.060561,-.259828),
//
//new Section("Complete"),








#if NARATION
	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\Nurbs Stitched Head Tutorial\\create-new-file.wav"),
#else
		new ClickButton(fileMenu),
		new Move_MenuItem("new     (Ctrl N)"),
		new Click,
#endif
		//new SetFieldValue("filename", "nurbs-stitched-head.smls"),
		//new ToggleField("save"),
		//new ClickYes(),

//new Section("Crap"),
//
//new ClickButton(newRectangle),
//new ClickButton(convertToPatch),
//new SelectNode(3),
//new SelectNode(4),
//new ToggleField("mirror"),
//new MoveToExitWindow(),
//new Click(),
//new MoveToExitSceneTree(),
//new Click(),
//new Section("Crap2"),
//
//new RectVert(-.628125,1.06875,.714375,-.26375),
//new Neutral(.52,-.02),
//
//new Scale1d(1.197704,-.697705),
//new TugCP(16,1.153863,-.593863),


new Section("Add nurbs lathe"),

new DragViewRot(.999619,.02483,-.012028,.160924),
new ClickButton(buildNurbsLatheForSelPart),

new AddCtrlPnt(.003125,-.003125),
new ClickButton(setFrontViewOrientation),

new AddCtrlPnt(.1,-.747748 - .08),
new AddCtrlPnt(.3,-.747748 - .08),
new AddCtrlPnt(.3,-.184657 - .08),
new AddCtrlPnt(.3,.152251 - .08),
new AddCtrlPnt(.3,.475651 - .08),
new AddCtrlPnt(.3,1.052251 - .08),
new AddCtrlPnt(.1,1.052251 - .08),

new ToggleField("done"),
new ClickButton(openControlPanel),

new ToggleField("endSP"),
new ToggleField("beginSP"),

new MoveToExitWindow(),
new Click(),

new ClickButton(openGridControl),

new ToggleField("show"),
new MoveToExitWindow(),
new Click(),

new Section("Convert to patch"),
new ClickButton(convertToPatch),

new ToggleField("done"),

new Section("Create skeleton"),
new ClickButton(setXRayEditMode),

new MoveToPivotPoint(3),
new Move3d(0, 1.052251 - .08),

new ClickButton(setAddBoneMode),
new AddCtrlPnt(0, .152251 - .08),
new AddCtrlPnt(0, -.747748 - .08),
new ToggleField("done"),

new Section("Name parts"),
new ClickButton(openSceneTree),

new MoveToNodeAsChild(l_shoulder),
new DoubleClick(),
new TypeString("l_shoulder"),
new NameNode(l_elbow, "l_elbow"),
new NameNode(l_wrist, "l_wrist\n"),

new Section("Paint color codes"),

new ClickButton(setPaintColorCodedControlPoints),

new SelectNode(l_shoulder),
new RectVert(-.403125,1.084375 - .08,.432291,.334375 - .08),
new SelectNode(l_elbow),
new RectVert(-.39375,.234375 - .08,.54375,-.857292 - .08),
new ClickButton(setAnimationMode),

new DecFieldX("period"),
new DragAnimSlider(.5),

new MoveToAnimRotPoint(0),
new Move3d(Vec3f(.141667,.993917,0 - .08)),
new ClickButton(playAnim),
new Wait(2),
new ToggleField("insert", 2),
new RectVert(-.39375,.225 - .08,.441667,.04375 - .08),
new ToggleField("loop", 1),
new ClickButton(playAnim),

new MoveToExitWindow(1),
new Click(),

new Section("Morph muscle"),

new ToggleField("pause"),
new DragAnimSlider(.5),
new ClickButton(togglePolyMorphCapture),
new ClickButton(toggleBackfaceSelect),

new RectVert(.25,.45625,.35625,.354167),
new TugCP(68,.4125,.487318),

new ClickButton(playAnim),
new Wait(5),
new DragViewRot(.071473,-.997438,.002906,.959294),
new Wait(2),
new DragViewRot(.048816,-.998518,.024081,2.816827),
new Wait(2),
new DragViewRot(-.083593,-.99051,-.1091,.142246),


new Section("Squash and stretch neck rings"),

new Section(Complete),
	};
	list+=EVENT_LIST(array0);
}
//new AddCtrlPnt(.418654,.522792),