/* Seamless3d

Copyright (C) 2001-2013 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Create_a_New_Seamless_File;
extern const char* Create_Skeleton_of_Parts;
extern const char* Add_a_Group;
extern const char* Build_the_Pelvis;
extern const char* Add_a_pink_group;
extern const char* Build_the_Left_Eye;
extern const char* Copy_the_Left_Eye_to_the_Right;
extern const char* Build_the_Neck;
extern const char* Build_the_Head;
extern const char* Add_a_Cream_Group;
extern const char* Build_the_Left_Wrist;
extern const char* Build_the_Left_Elbow;
extern const char* Build_the_Left_Shoulder;
extern const char* Copy_the_Left_Arm_to_the_Right;
extern const char* Add_a_Blue_Group;
extern const char* Build_the_Left_Ankle;
extern const char* Build_the_Left_Knee;
extern const char* Build_the_Left_Hip;
extern const char* Copy_the_Left_Leg_to_the_Right;
extern const char* Position_the_Limbs_and_Neck;
extern const char* Add_a_Green_Group;
extern const char* Place_the_Avatar_to_the_Floor;
extern const char* Move_the_Pivot_Points;
extern const char* Move_the_Eye_Pivot_Points;
extern const char* Move_the_Rest_of_the_Pivot_Points;
extern const char* Add_a_Gesture_Group;
extern const char* Setup_Animation;
extern const char* Record_the_poses;
extern const char* Complete;

extern const char* menu_paste;
extern const char* menu_import;
extern const char* menu_all_nodes_from_file;
extern const char* menu_import_bxx_av_studio;


extern const char* name_pelvis;
extern const char* name_tummy0;
extern const char* name_tummy1;
extern const char* name_thorax;
extern const char* name_neck;
extern const char* name_head;
extern const char* name_l_eyeball;
extern const char* name_r_eyeball;

extern const char* name_l_collar;
extern const char* name_l_shoulder;
extern const char* name_l_elbow;
extern const char* name_l_wrist;

extern const char* name_r_collar;
extern const char* name_r_shoulder;
extern const char* name_r_elbow;
extern const char* name_r_wrist;

extern const char* name_l_hip;
extern const char* name_l_knee;
extern const char* name_l_ankle;
	
extern const char* name_r_hip;
extern const char* name_r_knee;
extern const char* name_r_ankle;

extern const char* name_front_view;
extern const char* name_left_view;
extern const char* name_right_view;
extern const char* name_back_view;
extern const char* name_birds_eye_view;
extern const char* name_worms_eye_view;
extern const char* name_showcase_view;
extern const char* menu_delete;

extern const char* str_hello;

void InputEvent::preNurbsLatheAvDemo(){
	g_robotDemo->fileName="nurbs-stitched-avatar";
	g_robotDemo->function=InputEvent::nurbsLatheAvDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::nurbsLatheAvDemo(){

	const int seamless = 1;
	const int pelvis = 3;
	const int tummy0 = 4;
	const int tummy1 = 5;
	const int thorax = 6;
	const int neck = 7;
	const int head = 8;
	const int headEnd = 9;
	//const int l_eyeball = head+1;
	//const int r_eyeball = l_eyeball+1;

	const int l_collar = 10;
	const int l_shoulder = 11;
	int l_elbow = 12;
	int l_wrist = 13;
	const int l_handEnd = 14;

	const int r_collar = 15;
	const int r_shoulder = 16;
	int r_elbow = 17;
	int r_wrist =	18;
	const int r_handEnd = 19;

	const int l_hip = 20;
	int l_knee = 21;
	int l_ankle = 22;
	const int l_footEnd = 23;

	const int r_hip = 24;
	int r_knee = 25;
	int r_ankle = 26;
	const int r_footEnd = 27;

	const int buildGroup = 28;

	const int gestureGroup = 77;
	const int anim = 78;

	InputEvent* create_Skeleton_of_PartsArray[]={
		
		new Section("Create a new seamless file"),
		new ResizeSceneTreeWin(330, 643),
		new ClickButton(fileMenu),
		new Move_MenuItem("new     (Ctrl N)"),
		new Click,
		//new Section("Add floor & height guide"),
		//new ClickButton(floorBuild),
		//new ToggleField("zero_height"),
		new Section("Set vertical grid"),
new ClickButton(openGridControl),
new ToggleField("xyPlane"),
new DragViewPos(0,-1, 0,	.065625, .93125),
new MoveToExitWindow(),
new Click(),

new Section("Add lathe"),



new ClickButton(buildNurbsLatheForSelPart),

new AddCtrlPnt(0,0),
new AddCtrlPnt(0,-.5),

new AddCtrlPnt(.046593,.69398),
new AddCtrlPnt(.185911,.656373),
new AddCtrlPnt(.274854,.497663),
new AddCtrlPnt(.21684,.321949),
new AddCtrlPnt(.062704,.262949),
new AddCtrlPnt(.060585,.186733),
new AddCtrlPnt(.196761,.13799),
new AddCtrlPnt(.307827,.025263),
new AddCtrlPnt(.346767,-.154517),
new AddCtrlPnt(.278592,-.32827),
new AddCtrlPnt(.125,-.43125),
new AddCtrlPnt(0,-.43125),

new ToggleField("done"),
new ClickButton(convertToPatch),

new IncFieldX("control_staves"),
new IncFieldX("control_staves"),
new ToggleField("done"),


new Section("Extrude arms"),
new TugCP(178,.355448,.025263),
new ClickButton(extrudePatch),

new IncFieldX("distance", 19),
new IncFieldX("insertions"),
new ToggleField("cap"),
new ToggleField("done"),

new Section("Extrude legs"),
new TugCP(48,.32169,-.32827),
new ClickButton(extrudePatch),

new IncFieldX("distance",25),
new IncFieldX("insertions"),
new ToggleField("spiderWebCenter"),
new ToggleField("done"),


new Section("Rotate head"),

new ClickButton(setLeftViewOrientation),

new ClickButton(toggleBackfaceSelect),

new RectVert(-.415625,.9,.438542,.297917),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-.2125,.320834,0)),

new Rotate(0,-.2125,.8875),
new TugCP(236,-.117782,.5125),
new ClickButton(insertControlPoint),

new SelNurbsLine(245,258,.305096),
new ToggleField("done"),
new ClickButton(toggleZBufferCageMode),

new TugCP(258,.170827,.562497),
new TugCP(232,-.051115,.808507),
new DragViewRot(.011925,-.998209,-.058625,2.954376),
new TugCP(236,-.345321,.505293),
new TugCP(260,-.161926,.545083),
new TugCP(262,-.281457,.359699),
new DragViewRot(.151559,-.892177,-.425501,.802947),
new DragViewRot(-.484999,-.873026,-.051001,1.853598),
new TugCP(262,.207457,.387841),
new DragViewRot(-.559397,-.693052,-.454702,.427279),
new TugCP(262,.281419,.330353),
new DragViewRot(.791224,-.386145,-.474191,2.179374),
new DragViewRot(.782818,-.379756,-.492931,2.154939),

new TugCP(232,-.16223,-.103457),
new DragViewRot(.042782,-.997158,.062007,1.553811),
new ClickButton(quantiseViewOrientation),

new TugCP(202,-.293496,.300146),

new Section("Squash torso"),

new RectVert(.51875,-.6125,-.477083,.158333),

new Scale1d(0,.312755,-.151463),
new DragViewRot(.340617,-.891241,-.29945,.565228),


//new ClickButton(toggleBackfaceSelect),

new Section("Rotate arm"),
new ClickButton(setFrontViewOrientation),

new RectVert(.26875,.184375,.675,-.082292),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.309375,.045833,0)),

new Rotate(0,.720833,-.165625),
new TugCP(412,.284679,.123444),
new TugCP(340,.173032,.158823),


new Section("Rotate leg"),
new RectVert(.603125,-.65,.238542,-.227083),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.284375,-.429167,0)),

new Rotate(0,.579167,-.778125),
new TugCP(94,.321244,-.158684),
new DragViewRot(-.996965,.077543,-.006913,1.260827),
new ClickButton(selectRing),

new SelNurbsLine(21,22,.06321),
new ClickButton(quantiseViewOrientation),


new Scale1d(0,.235772,.000122),

new Scale1d(1,-.000001,.319868),
new ClickButton(setFrontViewOrientation),

new Section("More stuff3"),
new RectVert(.21875,-.34375,.575,-.654167),
new TugCP(524,.142423,-.565514),
new RectVert(.321875,.165625,.432292,-.069792),

new Scale1d(0,.363534,.061664),
new RectVert(.321875,.171875,.498958,-.065625),
new TugCP(434,.659185,-.046174),
new RectVert(.09375,-.53125,.416667,-.65625),

new Scale1d(1,.211834,-.547916),
//new TugCP(526,.191249,-.928986),
new TugCP(524,.138269,-1.000155),
new RectVert(-.403125,.184375,.373958,-.117708),
new ClickButton(toggleZBufferCageMode),


new Scale1d(0,.427228,.08131),
new RectVert(-.371875,-.134375,.446875,-.244792),

new Scale1d(0,.416821,-.155906),


new TugCP(414,.214934,.047119),
new TugCP(418,.219101,.047119),
new TugCP(432,.654997,.051334),
new TugCP(436,.654997,.051334),

new Section("More stuff4"),
new TugCP(506,.085897,-.44387),
new TugCP(524,.088268,-.995989),

new ClickButton(selectRing),
new SelNurbsLine(503,504,.059212),
new Scale1d(1,.195928,-.423004),
new TugCP(506,.085897,-.451407),

new ClickButton(insertControlPoint),
new SelNurbsLine(511,520,.582873),
new ToggleField("done"),


new Section("More stuff5"),

new ClickButton(insertControlPoint),

new SelNurbsLine(533,542,.698092),
new ToggleField("done"),
new ClickButton(insertControlPoint),

new SelNurbsLine(551,560,.080226),
new ToggleField("done"),

new Section("Scale feet"),
new RectVert(.034375,-.840625,.401042,-1.032292),

new Scale1d(0,1.069854,-.939602),
new ClickButton(setLeftViewOrientation),


new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.05,-.940625,0)),

new Scale1d(0,1.599232,-.940625),
new DragViewRot(.807925,-.237385,-.539356,1.279863),
new ClickButton(setHomeMode),

new DragViewRot(.854989,.465601,.228495,.744209),
new DragViewRot(.919856,.290617,.263453,.858495),

new DragViewRot(.714433,.43351,.549231,.373833),
new DragViewRot(.400025,-.902699,-.158473,1.177338),
new ClickButton(setFrontViewOrientation),

new ClickButton(setModellingMode),

new ClickButton(selectRing),

new SelNurbsLine(593,594,.118255),

new Scale1d(0,.439833,-.811269),
new ClickButton(selectRing),

new SelNurbsLine(575,576,.169537),

new Scale1d(0,.560567,-.641562),


new Section("Shape mouth and head"),
new ClickButton(setLeftViewOrientation),

new RectVert(-.625,.8,-.3875,.258333),
new TugCP(186,-.343885,.318278),
new TugCP(232,.126681,.769876),
new TugCP(228,-.188629,.291493),
new RectVert(-.60625,.9375,.327083,.285417),
new TugCP(238,-.105296,.28316),
new ClickButton(setFrontViewOrientation),

new ClickButton(toggleBackfaceSelect),

new Section("Shape mouth and head B"),

new DragViewRot(-.010389,-.998527,-.053252,1.67478),
new ClickButton(setLeftViewOrientation),

new RectVert(.284375,.5625,.284375,.5625),

new TugCP(258,.234927,.380659),
new ClickButton(setFrontViewOrientation),

new ClickButton(insertControlPoint),

new DragViewRot(.562831,.712378,-.419213,.554397),
new SelNurbsLine(233,234,.032271),
new ToggleField("done"),
new TugCP(268,.152048,.856364),
new ClickButton(setFrontViewOrientation),
new TugCP(238,0,.837366),

new ClickButton(selectRing),

new SelNurbsLine(199,200,.883833),

new Scale1d(1,0,.611997),

new Scale1d(0,.590685,.502515),
new ClickButton(insertControlPoint),

new SelNurbsLine(191,206,.1),
new ToggleField("done"),
new RectVert(-.11875,.615625,.139583,.392708),
///////////

new Section("Shape mouth and head C"),

new RectVert(-.109375,.56875,.119792,.427083),
new TugCP(208,0,.426682),
new MouseZoom(2.357948),
new ClickButton(centerViewToControlPoint),
new MouseZoom(4.594974),
new ClickButton(insertControlPoint),

new SelNurbsLine(193,208,.226999),
new ToggleField("done"),


new Section("Shape mouth and head D"),


new ClickButton(selectRing),

new SelNurbsLine(186,187,.449399),
new ClickButton(setLeftViewOrientation),

new ClickButton(toggleBackfaceSelect),

new TugCP(199,.355057,-.202914),
new ClickButton(setFrontViewOrientation),

new TugCP(206,-.158393,-.081248),
new TugCP(191,-.141862,-.171653),
new TugCP(193,0,-.175821),
new TugCP(206,-.15006,-.139582),
new TugCP(208,0,-.147916),
new TugCP(236,-.186062,-.041667),
new TugCP(238,0,-.062501),
new MouseZoom(1.4641),
new DragViewRot(-.004197,.993089,.117286,.456565),
new ClickButton(setFrontViewOrientation),

new TugCP(266,-.115484,.190137),
new ClickButton(toggleBackfaceSelect),

new ClickButton(extrudePatch),

new DecFieldX("distance",4),
new DragViewRot(.063633,.997796,-.018839,.831255),
new DecFieldX("distance"),
new ClickButton(insertControlPoint),

new SelNurbsLine(803,804,.062525),
new ToggleField("done"),
new ClickButton(setFrontViewOrientation),

new RectVert(-.09375,.2125,-.04375,.164583),
new TugCP(803,-.042004,.18165),
new TugCP(814,-.045706,.184637),
new TugCP(805,-.048943,.322291),
new TugCP(816,-.040145,.321111),
new TugCP(419,-.297635,-.027889),
new DragViewRot(-.534101,.791974,-.295826,1.467943),
new TugCP(204,-.359771,.262224),
new DragViewRot(.452008,.730829,.511447,2.194033),
new TugCP(204,-.104296,-.395214),
new DragViewRot(-.563176,.588979,.579601,1.604797),
new DragViewRot(-.574594,.650419,.496786,1.820314),
new TugCP(417,.127209,-.112496),
new TugCP(202,.115568,-.225237),
new DragViewRot(.802989,.066588,.592263,.372292),
new ClickButton(setHomeMode),

new DragViewRot(.306563,.944388,.118956,.818227),
new MouseZoom(1),
new DragViewRot(.146166,.988594,-.036285,.731935),
new ClickButton(setFrontViewOrientation),

new DragViewPos(-.072917,-.960015,-.292903,-.684375,.0875),
new ClickButton(setModellingMode),

new TugCP(204,-.337704,.443919),
new TugCP(234,-.372331,.465944),
new ClickButton(setHomeMode),

new DragViewRot(.199742,.085343,.976125,1.215052),
new DragViewRot(.80473,.579353,.129458,.422383),


new Section("Squash torso"),

new ClickButton(setFrontViewOrientation),

new ClickButton(setModellingMode),

new RectVert(.325,-.471875,-.4375,.209375),
new ClickButton(toggleBackfaceSelect),

new RectVert(.321875,-.484375,-.446875,.213541),

new Scale1d(0,.29521,-.12775),
new RectVert(.071875,.215625,.736458,-.044792),

new Scale1d(1,.37978,.408592),
new TugCP(556,.08534,.191801),
new RectVert(.528125,.225,.596875,.04375),
new TugCP(578,.632101,.081664),
new TugCP(133,.018055,.129832),
new TugCP(168,.022221,.129832),
new TugCP(166,-.072917,.125665),
new ClickButton(toggleBackfaceSelect),




new Section("Shape torso"),
new ClickButton(setHomeMode),
new ClickButton(setFrontViewOrientation),

new ClickButton(setModellingMode),

new ClickButton(toggleBackfaceSelect),

new ClickButton(toggleBackfaceSelect),

new ClickButton(setLeftViewOrientation),

new TugCP(166,.414697,.142331),
new TugCP(164,.418863,.138165),
new TugCP(358,.374318,.186309),
new TugCP(356,.370152,.186309),//
new TugCP(106,.447413,-.110365),
new TugCP(104,.447413,-.114532),//

new TugCP(164,.393863,.138165),
new TugCP(166,.389697,.142331),
new TugCP(133,.195866,.150665),
new TugCP(364,.232078,.194642),
new TugCP(100,.117317,-.114532),
new DragViewRot(.177324,.982503,.056956,1.025853),
new DragViewRot(.865312,.012168,.501086,.197261),
new ClickButton(setFrontViewOrientation),

new Section("Insert rings for arms"),

new ClickButton(selectRing),

new SelNurbsLine(561,562,.549158),

new Scale1d(0,.07901,.139479),
new ClickButton(selectRing),

new SelNurbsLine(579,580,.266446),

new Scale1d(0,.644948,.140863),
new ClickButton(insertControlPoint),

new SelNurbsLine(571,580,.812531),
new ClickButton(insertControlPoint),

new SelNurbsLine(569,578,.676363),
new ToggleField("done"),
new ClickButton(insertControlPoint),

new SelNurbsLine(583,592,.81116),
new ToggleField("done"),
new ClickButton(insertControlPoint),

new SelNurbsLine(628,637,.978344),
new ToggleField("done"),
new ClickButton(insertControlPoint),

new SelNurbsLine(619,628,.121109),
new ToggleField("done"),
new ClickButton(insertControlPoint),

new SelNurbsLine(85,100,.115127),
new ToggleField("done"),
new ClickButton(selectRing),

new SelNurbsLine(112,113,.875491),

new Scale1d(1,-.072917,-.006907),
new TugCP(102,-.224328,.041572),

///////////////////
new Section("refine crotch and shoulders"),


new TugCP(102,-.240516,.005315),
new TugCP(79,-.19134,-.334118),
new ClickButton(toggleBackfaceSelect),

new TugCP(62,-.195507,-.334118),
new TugCP(64,-.072917,-.334118),
new ClickButton(toggleBackfaceSelect),

new ClickButton(insertControlPoint),

new SelNurbsLine(130,145,.978238),
new ToggleField("done"),
new TugCP(160,-.201951,-.263602),
new ClickButton(toggleBackfaceSelect),

new TugCP(164,-.199822,-.263602),
new TugCP(166,-.072917,-.261474),
new DragViewRot(.018587,-.997954,-.061177,1.404467),
new ClickButton(setLeftViewOrientation),

new TugCP(49,.151672,-.329952),
new TugCP(62,.438058,-.346618),
new TugCP(64,.429725,-.346618),
new DragViewRot(.012615,.982218,-.187319,.772057),
new DragViewRot(-.681975,-.492117,-.541047,1.687982),
new TugCP(49,-.296038,-.2184),
new DragViewRot(.494099,.583034,-.644933,.49156),
new ClickButton(setHomeMode),

new DragViewRot(.673658,.738017,.038944,3.084306),
new DragViewRot(.661039,.703806,.260161,3.62083),
new ClickButton(setModellingMode),

///////////////






new Section("Refine"),

new ClickButton(setHomeMode),

new DragViewRot(.935646,-.203203,.288573,1.964881),
new DragViewRot(.77983,-.383505,.494761,2.271745),
new DragViewRot(.73442,-.668776,-.115611,.285802),
new ClickButton(setFrontViewOrientation),

new ClickButton(setModellingMode),

new RectVert(-.659375,.209375,.530209,.061458),
new ClickButton(setBirdsEyeViewOrientation),


new Scale1d(1,-.072916,.677291),
new DragViewRot(.004047,-.99926,.038247,1.554819),
new ClickButton(setLeftViewOrientation),

new TugCP(104,.40234,.037461),
new TugCP(106,.404621,.03747),
new DragViewRot(.026947,-.935138,.353257,2.711609),
new TugCP(108,.12635,.275505),
new DragViewRot(.015888,-.882871,.469347,2.60024),
new TugCP(138,.189404,.270268),
new DragViewPos(-.072917,-.960015,-.292903,.234375,.203125),
new TugCP(168,.217538,.207092),
new DragViewRot(.428467,-.899777,-.082568,3.492926),
new TugCP(104,-.010498,.032114),
new DragViewRot(.273833,-.949302,.154406,1.262028),
new ClickButton(setLeftViewOrientation),

new TugCP(100,.177873,.024973),
new TugCP(102,.29271,.030315),
new DragViewRot(.177592,-.972674,-.149555,2.303582),
new DragViewRot(.187446,-.971574,-.144594,2.44024),
new ClickButton(setHomeMode),

new DragViewRot(.606405,-.765475,.215222,1.966402),
new ClickButton(setModellingMode),

new TugCP(390,-.026421,.371179),
new DragViewRot(.478887,-.794078,.374309,2.505438),
new TugCP(360,-.212308,.389081),
new DragViewRot(.458347,-.660045,.595196,1.575889),
new ClickButton(setLeftViewOrientation),

new TugCP(412,.227425,.190475),
new DragViewRot(.488014,.864455,-.120667,1.875897),
new ClickButton(setHomeMode),

new DragViewRot(.040781,.971167,-.234887,3.985099),
new ClickButton(setModellingMode),

new TugCP(168,.305899,-.075506),
new DragViewRot(-.051562,.996586,-.064476,5.152723),
new TugCP(168,.427621,-.230202),
new ClickButton(setHomeMode),

new DragViewRot(-.611555,.18414,-.769476,3.727922),
new DragViewRot(-.522963,.817621,.240841,3.956034),
new DragViewRot(-.206059,-.967268,-.148099,5.594129),
new ClickButton(setFrontViewOrientation),

///////
new Section("Refine 2"),

new ClickButton(setModellingMode),

new ClickButton(toggleBackfaceSelect),

new ClickButton(toggleZBufferCageMode),

new DragViewRot(-.702195,-.578434,.415135,3.96363),
new TugCP(66,-.301505,.432797),
new DragViewRot(-.628644,-.438215,-.642475,2.30676),
new ClickButton(setHomeMode),

new DragViewRot(-.945152,-.276548,-.173809,3.38517),
new DragViewRot(.098174,.991648,-.083644,3.944991),
new DragViewRot(.140897,.985785,.091518,1.717884),
new DragViewRot(.142805,.982534,.119304,1.490223),
new DragViewRot(.811599,-.584199,-.004347,.335346),

////////
new Section("Insert 5th arm line into eye"),
new DragViewRot(-.095432,.963678,-.249433,2.128287),
new ClickButton(setModellingMode),

new ClickButton(insertControlPoint),

new SelNurbsLine(877,878,.829126),
new DragViewRot(.842894,.079544,-.532168,.46931),
new SelNurbsLine(1011,1013,.5),
new ToggleField("done"),
new ClickButton(setFrontViewOrientation),

new ClickButton(toggleBackfaceSelect),

new RectVert(-.375,.659375,-.158334,.576041),
new TugCP(1303,-.37427,.634734),
new RectVert(-.165625,.55625,-.105208,.504166),
new TugCP(1226,-.150271,.552582),
new DragViewRot(.573505,.720633,-.389591,.509545),

new Section("Filter tugs"),
new ClickButton(openTransformCP),
new ToggleField("xTug"),
new MoveToExitWindow(),
new Click(),
new DragViewRot(.560041,.781333,-.275449,1.969091),
new TugCP(669,-.038605,.184991),
new ClickButton(centerViewToControlPoint),

new MouseZoom(2.853117),
new TugCP(669,.008333,.070833),
new TugCP(643,.037562,.281436),
new TugCP(695,-.028436,-.130377),
new TugCP(721,-.034255,-.17449),
new TugCP(747,-.04784,-.207063),
new TugCP(773,-.050386,-.246858),
new DragViewRot(.546789,.791462,-.273146,2.360414),
new ClickButton(toggleZBufferCageMode),

new TugCP(647,-.338611,.341856),
new TugCP(673,-.217491,-.01072),
new TugCP(699,-.118332,-.320144),
new TugCP(725,-.086273,-.40839),
new TugCP(751,-.071308,-.45934),
new TugCP(777,-.045689,-.540458),
new ClickButton(toggleZBufferCageMode),

new DragViewRot(-.136694,.812468,-.566754,2.803267),
new TugCP(146,-.563978,-.46432),
new ClickButton(centerViewToControlPoint),

new ClickButton(openTransformCP),
new ToggleField("xTug"),
new ToggleField("yTug"),
new TugCP(108,-.038984,.125142),
new TugCP(146,.008333,.0875),
new TugCP(184,.067546,-.054299),
new TugCP(979,.13985,-.295231),
new ClickButton(toggleZBufferCageMode),

new TugCP(979,.12735,-.199397),
new ClickButton(toggleZBufferCageMode),

new TugCP(1001,.248731,-.359279),
new TugCP(1023,.279774,-.456808),
new ClickButton(centerViewToControlPoint),

new DragViewRot(-.065984,.774431,-.629208,2.456225),
new TugCP(1045,.091598,.013831),
new TugCP(1067,.102716,-.023615),
new DragViewRot(.358408,-.596008,-.718553,2.570883),
new TugCP(1045,.129767,.320787),
new DragViewRot(.316496,-.721679,-.615638,2.449517),
new TugCP(1023,-.020833,.083333),
new TugCP(1045,.130639,.153177),
new MouseZoom(1.21),
new DragViewRot(-.030684,-.911071,.411107,2.436902),
new TugCP(1122,-.53643,.369103),
new TugCP(1100,-.534317,.487797),
new DragViewRot(.279839,-.938059,-.204292,2.137744),
new DragViewRot(.310504,-.869572,-.383968,1.885389),
new TugCP(1144,-.117128,-.450414),
new DragViewRot(.098937,-.667782,-.737753,.913162),
new TugCP(1144,.36941,-.378815),

new Section("Filter tugs2"),
new ClickButton(insertControlPoint),

new SelNurbsLine(1185,1186,.056621),
new ToggleField("done"),
new ClickButton(insertControlPoint),

new DragViewRot(-.752486,-.146916,-.642013,.768813),
new SelNurbsLine(1320,1321,.164066),
new ToggleField("done"),
new DragViewRot(-.589437,.804533,-.072732,2.739995),
new ClickButton(insertControlPoint),

new SelNurbsLine(1512,1513,.875679),
new ToggleField("done"),
new DragViewRot(-.668411,.594177,-.447416,2.338909),
new TugCP(1347,.035853,-.264175),
new TugCP(1381,.053193,-.271162),
new DragViewRot(.375383,-.446974,-.811974,2.02265),
new TugCP(1373,-.473638,.242617),
new TugCP(1339,-.448568,.226013),
new TugCP(1385,-.493428,-.159346),
new TugCP(1351,-.464613,-.164164),
new ClickButton(toggleZBufferCageMode),

new TugCP(1305,-.155572,.026182),
new TugCP(1317,-.168211,-.101089),
new ClickButton(toggleZBufferCageMode),

//new Section(Complete),

new TugCP(1458,-.187768,-.606406),
new TugCP(1237,.069241,-.084261),
new TugCP(228,.128896,-.129203),
new TugCP(182,.201466,-.1634),
new TugCP(136,.304414,-.218568),
new DragViewRot(-.097022,.063461,-.993257,1.717824),
new TugCP(1283,.211887,-.176202),
new ClickButton(toggleZBufferCageMode),

new DragViewRot(-.313954,-.122488,-.941504,1.840032),
new TugCP(1249,.431131,-.197213),
new DragViewRot(.052733,.004811,-.998597,1.800605),
new TugCP(1249,.361058,-.305361),

new DragViewRot(.158716,.311573,-.936873,1.744656),

new ClickButton(toggleBackfaceSelect),

new DragViewRot(-.738708,-.672762,-.041239,3.325608),

new TugCP(1500,.046921,.494326),
new TugCP(1466,.250018,.452751),
new TugCP(1432,.456081,.374807),
new DragViewRot(-.167744,.060532,-.98397,4.535403),
new DragViewRot(.045175,-.533154,-.844811,3.914644),
new DragViewRot(-.443152,-.819069,-.364338,3.587497),
new DragViewRot(-.444304,-.895409,.028917,3.24503),
new TugCP(86,.152386,.619032),
new ClickButton(centerViewToControlPoint),

new MouseZoom(2.853117),
new ClickButton(openTransformCP),

new ToggleField("yTug"),
new MoveToExitWindow(),
new Click(),


new Section("Smooth out crotch"),

new TugCP(86,-.024999,-.025001),
new TugCP(84,.095983,-.184435),
new DragViewRot(-.158377,-.252953,.954427,3.109377),
new TugCP(55,-.120135,-.211329),
new DragViewRot(.043928,.000841,.999034,3.054119),
new TugCP(55,.096151,.042753),
new DragViewRot(-.417904,-.166681,.89307,3.099071),
new DragViewRot(-.596697,-.220968,.771444,3.134229),
new TugCP(55,-.468803,-.126969),
new ClickButton(setHomeMode),

new DragViewRot(-.318489,-.894012,.315131,2.901549),
new DragViewRot(-.361257,-.926308,-.106995,2.025246),
new DragViewRot(-.358453,.927427,-.106726,1.052477),
new MouseZoom(1),
new DragViewRot(.097899,.988912,-.111669,3.1923),
new DragViewRot(.52686,.828014,.191862,.657254),


new Section("Round arms 2"),

new ClickButton(setHomeMode),

new ClickButton(setModellingMode),

new DragViewRot(.450631,-.779927,.434334,.338452),
new MouseZoom(1.4641),
new DragViewPos(-.073516,-.597796,.088165,-.68125,.9625),
new TugCP(544,-.669843,.955568),
new ClickButton(centerViewToControlPoint),

new MouseZoom(3.138429),
new DragViewRot(.477499,-.787312,.390045,.374067),
new TugCP(544,-.025,-.05),
new DragViewRot(-.228359,.965451,.125525,2.072236),
new DragViewPos(.213148,-1.344403,-.158967,.159375,.1),
new DragViewPos(.213148,-1.344403,-.158967,.15,.1),
new TugCP(671,.221028,.116024),
new DragViewRot(-.651662,.754971,-.073185,3.076223),
new TugCP(558,.022462,.01371),
new DragViewRot(-.626622,.660983,-.412852,2.97272),
new TugCP(572,-.21193,.047887),
new DragViewRot(-.184263,.293714,-.937966,1.500399),
new TugCP(586,-.349981,-.449675),
new DragViewRot(.044653,-.135289,-.989799,1.437379),
new TugCP(600,-.345073,-.561504),
new DragViewRot(-.13317,-.357865,-.924229,1.464524),
new TugCP(614,-.431183,-.610733),
new DragViewRot(-.249962,-.414238,-.875172,1.764697),
new ClickButton(openTransformCP),

new ToggleField("xTug"),
new TugCP(795,-.568248,-.418131),
new TugCP(829,-.507851,.115661),
new TugCP(863,-.445267,.565172),
new TugCP(897,-.425141,.684337),
new TugCP(931,-.418113,.794805),
new TugCP(965,-.398472,.914731),
new TugCP(977,-.646971,.90845),
new TugCP(943,-.654114,.79686),
new TugCP(909,-.677809,.682225),
new TugCP(875,-.706267,.517231),
new TugCP(841,-.760513,.088564),
new DragViewRot(-.310538,-.020415,-.950342,1.606666),
new TugCP(807,-.968476,-.264182),
new DragViewRot(.273057,.694405,-.665765,1.671721),
new DragViewRot(.350281,.771765,-.530737,1.833906),
new TugCP(807,-.980192,-.171412),
new TugCP(841,-.883372,-.03462),
new TugCP(875,-.838326,.050929),
new DragViewRot(-.178918,.94514,.273309,3.279356),
new DragViewRot(-.483193,.272414,.832055,2.707197),
new TugCP(829,.855738,.190962),
new TugCP(347,.470927,.455405),
new DragViewRot(-.668624,.743056,-.028447,3.228043),
new DragViewRot(-.6737,.732056,-.101101,3.296393),
new ClickButton(openTransformCP),

new ToggleField("xTug"),
new TugCP(507,.425389,-.418329),
new TugCP(493,.201349,-.394853),
new DragViewRot(-.675138,.643147,.361318,2.770158),
new TugCP(507,.597683,-.762779),
new DragViewRot(-.767512,.52733,-.364485,2.953591),
new TugCP(493,-.124752,-.196107),
new DragViewRot(-.867775,.485461,-.106276,3.587326),
new DragViewRot(-.890006,.455664,-.016126,3.947829),
new TugCP(507,.894451,.218827),
new DragViewRot(-.796597,.017889,.604246,3.109157),
new TugCP(1685,.703543,.228814),
new TugCP(1683,.696905,.457088),
new DragViewRot(-.019432,-.130246,.991291,2.596642),
new TugCP(542,-.117883,.289448),
new TugCP(669,-.295487,.232021),
new DragViewRot(-.282645,-.152506,.947024,2.733212),
new TugCP(556,-.09965,.347209),
new DragViewRot(-.290699,-.017792,.956649,3.112787),
new MouseZoom(1.61051),
new DragViewRot(.525679,-.544954,.653213,5.959131),
new TugCP(612,.163805,-.386646),
new TugCP(598,.221781,-.328016),
new DragViewPos(.213148,-1.344403,-.158967,.209375,-.2125),
new TugCP(584,.244239,-.229647),
new DragViewRot(.317653,-.890729,.325114,5.696401),
new TugCP(586,.098867,-.202115),
new TugCP(600,.089284,-.323132),
new DragViewRot(-.072972,-.926967,.367979,3.179557),
new TugCP(493,-.29294,.181236),
new TugCP(1685,-.250622,.147051),
new DragViewRot(-.035381,-.80715,.589285,5.61667),
new ClickButton(setFrontViewOrientation),

new ClickButton(selectRing),

new SelNurbsLine(597,598,.079869),

new Scale1d(1,.343277,-.240937),
new ClickButton(selectRing),

new SelNurbsLine(583,584,.393936),

new Scale1d(1,.343277,-.128672),


new Section("Create hands"),
new ClickButton(setBirdsEyeViewOrientation),

new TugCP(313,-.819574,.350576),
new TugCP(311,-.825022,.263127),
new ClickButton(extrudePatch),

new ToggleField("spiderWebCenter"),
new IncFieldX("insertions"),
new IncFieldX("distance",18),
new ToggleField("done"),

new ClickButton(selectRing),
new SelNurbsLine(1758,1759,.229126),

new Scale1d(0,-.887027,.26164),
new TugCP(1765,-.824579,.22118),
new TugCP(311,-.82002,.170665),
new ClickButton(extrudePatch),

new ToggleField("spiderWebCenter"),
new IncFieldX("insertions"),
new IncFieldX("distance",17),
new ToggleField("done"),


new ClickButton(selectRing),

new SelNurbsLine(1830,1831,.339414),

new Scale1d(0,-.878661,.152531),
new TugCP(1837,-.819021,.120166),

new Scale1d(1,-.958322,.811394),
new ClickButton(selectRing),

new SelNurbsLine(1848,1849,.32283),

new Scale1d(0,-1.019783,.121643),
new TugCP(293,-.815407,.367243),
new ClickButton(extrudePatch),

new ToggleField("spiderWebCenter"),
new IncFieldX("insertions"),
new IncFieldX("distance",17),
new ToggleField("done"),
/////////
new ClickButton(selectRing),

new SelNurbsLine(1908,1909,.155666),

new Scale1d(0,-.874365,.375655),
new TugCP(1909,-.828387,.352314),

new Scale1d(1,-.663429,1.068378),
new ClickButton(selectRing),

new SelNurbsLine(1921,1922,.622357),

new Scale1d(0,-1.012262,.40942),
new ClickButton(selectRing),

new SelNurbsLine(1742,1743,.035464),

new Scale1d(0,-1.036729,.261874),
new TugCP(869,-.639616,.099926),
new ClickButton(extrudePatch),

new ToggleField("spiderWebCenter"),
new IncFieldX("insertions"),
new IncFieldX("distance",13),
new ToggleField("done"),
new ClickButton(selectRing),

new SelNurbsLine(2068,2069,.248043),

new Scale1d(1,-.600669,-.030616),

new Rotate(0,-.198958,-.230208),
new TugCP(2071,-.762553,-.011113),
new ClickButton(selectRing),

new SelNurbsLine(2050,2051,.160772),

new Scale1d(1,-.624848,.074747),

new Scale1d(0,-.13125,.06875),

new Scale1d(0,.060503,.069042),
new TugCP(2053,-.679711,.097936),
new ClickButton(selectRing),

new SelNurbsLine(953,954,.921045),

new Scale1d(1,-.564231,.504508),
new ClickButton(setFrontViewOrientation),


new Scale1d(1,-.564231,-.142739),
new ClickButton(selectRing),

new SelNurbsLine(930,931,.435496),

new Scale1d(1,-.262278,.018885),
new ClickButton(setBirdsEyeViewOrientation),


new Scale1d(1,-.262278,.620913),
new TugCP(842,-.635446,.37285),
new TugCP(840,-.63972,.325928),
new TugCP(759,-.700873,.389478),
new TugCP(793,-.763686,.406096),
new DragViewRot(.618962,.708185,-.339647,.601568),

new Section("Refine hands"),
new ClickButton(setFrontViewOrientation),
new ClickButton(openTransformCP),

new ToggleField("xTug"),
new ToggleField("zTug"),
new MoveToExitWindow(),
new Click(),

new TugCP(799,-.767956,-.429344),
new TugCP(765,-.730141,-.435698),
new TugCP(848,-.60638,-.440186),
new TugCP(787,-.784623,-.355041),
new TugCP(753,-.721806,-.346913),
new TugCP(836,-.660545,-.351306),
new TugCP(838,-.656468,-.343453),
new TugCP(755,-.7094,-.34345),
new TugCP(789,-.801388,-.351778),
new DragViewRot(.541598,.839854,-.036289,3.182657),
new TugCP(840,-.042941,-.713158),
new TugCP(757,-.011979,-.776917),
new TugCP(791,.019493,-.84653),
new TugCP(844,-.115058,-.749465),
new TugCP(761,-.08493,-.81783),
new TugCP(795,-.04385,-.882323),
new TugCP(846,-.113889,-.756579),
new TugCP(763,-.091049,-.820342),
new TugCP(797,-.05652,-.871536),
new DragViewRot(.693161,-.650593,-.310252,1.000703),
new DragViewRot(-.589677,-.806727,.038384,.597513),
new DragViewRot(-.952253,-.233331,.196903,1.405787),
new DragViewRot(.934204,.332873,.128292,1.805464),
new ClickButton(openTransformCP),

new ToggleField("xTug"),
new ToggleField("zTug"),
new MoveToExitWindow(),
new Click(),
new TugCP(1965,-.953141,-.102252),
new TugCP(1871,-.893868,-.211368),
new TugCP(801,-.811719,-.265742),
new DragViewRot(.940551,.240858,.239482,1.827135),
new TugCP(842,-.760074,.046127),
new TugCP(840,-.725758,.000158),
new TugCP(757,-.787166,-.022165),
new TugCP(2071,-.687263,-.346297),
new TugCP(2053,-.656148,-.219841),
new TugCP(767,-.703919,-.222593),
new TugCP(2053,-.681148,-.219841),
new DragViewRot(-.634902,.102642,-.765744,1.198653),
new DragViewRot(.995978,-.030129,-.084381,1.53004),
new DragViewRot(-.552176,.380203,-.741988,1.449789),
new DragViewRot(.961836,.094837,-.256668,.998289),
new ClickButton(setHomeMode),

new DragViewRot(-.880985,.152627,-.447852,5.195539),
new MouseZoom(1.1),
new DragViewRot(-.878085,-.457791,-.139262,5.490257),
new DragViewPos(.195879,-1.123293,-.367466,-.265625,-.53125),

new Section(Complete),
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);
}
//new AddCtrlPnt(.418654,.522792),