/* Seamless3d

Copyright (C) 2001-2014 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"

#define NARATION 1

extern const char* Create_a_New_Seamless_File;
extern const char* Create_Skeleton_of_Parts;
extern const char* Add_a_Group;
extern const char* Build_the_Pelvis;
extern const char* Add_a_pink_group;
extern const char* Build_the_Left_Eye;
extern const char* Copy_the_Left_Eye_to_the_Right;
extern const char* Build_the_Neck;
extern const char* Build_the_Head;
extern const char* Add_a_Cream_Group;
extern const char* Build_the_Left_Wrist;
extern const char* Build_the_Left_Elbow;
extern const char* Build_the_Left_Shoulder;
extern const char* Copy_the_Left_Arm_to_the_Right;
extern const char* Add_a_Blue_Group;
extern const char* Build_the_Left_Ankle;
extern const char* Build_the_Left_Knee;
extern const char* Build_the_Left_Hip;
extern const char* Copy_the_Left_Leg_to_the_Right;
extern const char* Position_the_Limbs_and_Neck;
extern const char* Add_a_Green_Group;
extern const char* Place_the_Avatar_to_the_Floor;
extern const char* Move_the_Pivot_Points;
extern const char* Move_the_Eye_Pivot_Points;
extern const char* Move_the_Rest_of_the_Pivot_Points;
extern const char* Add_a_Gesture_Group;
extern const char* Setup_Animation;
extern const char* Record_the_poses;
extern const char* Complete;

extern const char* menu_paste;
extern const char* menu_import;
extern const char* menu_all_nodes_from_file;
extern const char* menu_import_bxx_av_studio;


extern const char* name_pelvis;
extern const char* name_tummy0;
extern const char* name_tummy1;
extern const char* name_thorax;
extern const char* name_neck;
extern const char* name_head;
extern const char* name_l_eyeball;
extern const char* name_r_eyeball;

extern const char* name_l_collar;
extern const char* name_l_shoulder;
extern const char* name_l_elbow;
extern const char* name_l_wrist;

extern const char* name_r_collar;
extern const char* name_r_shoulder;
extern const char* name_r_elbow;
extern const char* name_r_wrist;

extern const char* name_l_hip;
extern const char* name_l_knee;
extern const char* name_l_ankle;
	
extern const char* name_r_hip;
extern const char* name_r_knee;
extern const char* name_r_ankle;

extern const char* name_front_view;
extern const char* name_left_view;
extern const char* name_right_view;
extern const char* name_back_view;
extern const char* name_birds_eye_view;
extern const char* name_worms_eye_view;
extern const char* name_showcase_view;
extern const char* menu_delete;

extern const char* str_hello;

void InputEvent::preNurbsLatheAvDemo(){
	g_robotDemo->fileName="nurbs-stitched-avatar";
	g_robotDemo->function=InputEvent::nurbsLatheAvDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::nurbsLatheAvDemo(){

	const int seamless = 1;
	const int pelvis = 3;
	const int tummy0 = 4;
	const int tummy1 = 5;
	const int thorax = 6;
	const int neck = 7;
	const int head = 8;
	const int headEnd = 9;
	//const int l_eyeball = head+1;
	//const int r_eyeball = l_eyeball+1;

	const int l_collar = 10;
	const int l_shoulder = 11;
	int l_elbow = 12;
	int l_wrist = 13;
	const int l_handEnd = 14;

	const int r_collar = 15;
	const int r_shoulder = 16;
	int r_elbow = 17;
	int r_wrist =	18;
	const int r_handEnd = 19;

	const int l_hip = 20;
	int l_knee = 21;
	int l_ankle = 22;
	const int l_footEnd = 23;

	const int r_hip = 24;
	int r_knee = 25;
	int r_ankle = 26;
	const int r_footEnd = 27;

	const int buildGroup = 28;

	const int gestureGroup = 77;
	const int anim = 78;

	InputEvent* create_Skeleton_of_PartsArray[]={
		
new Section("Show rings"),
		new ShowFile("C:\\Users\\thyme\\Documents\\march-vlog\\heads-list\\show-only-mouth-structure-Kiki.smls"),
new ClickButton(selectRing),
#if NARATION
	new DemoSound("C:\\Documents and Settings\\thyme\\Documents\\march-vlog\\kikis-2-mouth-rings-b.wav"),
#endif
new SelNurbsLine(580,581,.087224),
new TypeVirtKey('R'),
new SelNurbsLine(534,535,.276952),


//new DragViewRot(-.010501,-.999641,.024641,1.484899, .090625,-.2375),
new DragViewRot(0,-1,0,PI * .5, .090625,-.2375),
//new ClickButton(quantiseViewOrientation),
new TypeVirtKey('R'),
new SelNurbsLine(576,577,.298892),
new DemoMove(-.2625,-.234375),
new DemoMove(-.26875,-.146875),
new DemoMove(-.2625,-.234375),
new DemoMove(-.26875,-.146875),
new DemoMove(-.2625,-.234375),
new DemoMove(-.26875,-.146875),


new DragViewRot(1,0,0,0,-.2625,-.234375),
new TypeVirtKey('R'),
new SelNurbsLine(542,543,.524955),
new TugCP(541,.435885,-.319797),
new DragViewRot(-.99908,-.034031,.026087,1.560444, .435885,-.319797),
new TugCP(585,.453714,.019927),
new DragViewRot(.642277,.607885,.466856,.050984, .453714,.019927),
new TypeVirtKey('R'),
new SelNurbsLine(583,584,.92704),

new DemoMove(.384375,-.340625),
new DemoMove(.478125,-.309375),
new DemoMove(.375,-.25625),
new TypeVirtKey('R'),
new SelNurbsLine(538,539,.120847),
new DemoMove(.478125,-.309375),
new DemoMove(.384375,-.340625),

new Section(Complete),
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);
}
//new AddCtrlPnt(.418654,.522792),