/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <wininet.h>

#include "seamless3d.h"
#include "script.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#define MAX_BUFF_SIZE  0x40000
#define DEST_BUFF_SIZE 0x40000

#ifdef DX8
struct IDirect3DTexture8;
typedef IDirect3DTexture8 IDirect3DTexture;
#endif
#ifdef DX9
struct IDirect3DTexture9;
typedef IDirect3DTexture9 IDirect3DTexture;
#endif
extern ScenePtr g_scene;

HINTERNET g_hInternetSession;
char g_szAgent[]={"Seamless3d Viewer"};

extern OpenNetFilePtr g_openNetFile;
void checkForNameClash(M_Node& importDefList, M_Node& existingDefList);
void finishImportNodesFromFile();

void zippedBufToString(String& str, M_<char>& zippedBuf){
	if(zippedBuf.length){
		static M_<char> unzippedBuf;
		if(zippedBuf.length * 10 > unzippedBuf.length){
			unzippedBuf.length = zippedBuf.length * 10;
		}
		unsigned long destLength=unzippedBuf.length;
		uLong sourceLength=zippedBuf.length;
		int info=uncompress(reinterpret_cast<Bytef*>(unzippedBuf.getArray()), reinterpret_cast<uLongf*>(&destLength),	reinterpret_cast<Bytef*>(zippedBuf.getArray()), sourceLength);
		if(info==Z_OK){
			if(destLength==unzippedBuf.length){
				unzippedBuf+=0;
			}
			else{
				unzippedBuf[destLength]=0;
			}
			str=unzippedBuf.getArray();
		}
		else if(info==Z_MEM_ERROR){
			info=info;
		}
		else if(info==Z_BUF_ERROR){
			info=info;
		}
		else if(info==Z_DATA_ERROR){
			info=info;
		}
	}
	else{
		str="";
	}
}
bool ImageTexture::openUrl(){
	if(g_downloadQue.length){
		return false;
	}
	dLog("ImageTexture::openUrl");
	HINTERNET& _hInternetOpenUrl=*reinterpret_cast<HINTERNET*>(&hInternetOpenUrl);

	String fullUrl;

	const M_String& url=this->url;
	for(int i=0; i<url.length; i++){
		if(url[i][0] == 'h' && url[i][1] == 't' && url[i][1] == 't' && url[i][1] == 'p' && url[i][1] == ':'){
			fullUrl=url[i];
		}
		else{
			dynamic_cast<Download*>(urlPathNode.p)->getUrlPath(fullUrl);
			fullUrl+=url[i];
		}
		if((_hInternetOpenUrl=InternetOpenUrl( g_hInternetSession, fullUrl.c_str(),NULL,0,0,0))!=NULL){
			g_downloadQue+=this;
			dLog("ImageTexture g_downloadQue+=this");
			return true;
		}
	}
	msG("failed to open ImageTexture URL", MB_ICONEXCLAMATION);
	dLog("*ImageTexture::openUrl failed!*");
	return false;
}
bool ImageTexture::download(){
	return false;
}
bool TextureEffect::openUrl(){
	if(g_downloadQue.length){
		return false;
	}
	dLog("TextureEffect::openUrl");
	HINTERNET& _hInternetOpenUrl=*reinterpret_cast<HINTERNET*>(&hInternetOpenUrl);

	String fullUrl;

	const String& url = this->url;
	if(url[0] == 'h' && url[1] == 't' && url[1] == 't' && url[1] == 'p' && url[1] == ':'){
		fullUrl = url;
	}
	else{
		dynamic_cast<Download*>(urlPathNode.p)->getUrlPath(fullUrl);
		fullUrl += url;
	}
	if((_hInternetOpenUrl = InternetOpenUrl(g_hInternetSession, fullUrl.c_str(),NULL,0,0,0))!=NULL){
		g_downloadQue+=this;
		dLog("TextureEffect g_downloadQue+=this");
		return true;
	}
	//msG("failed to open TextureEffect URL", MB_ICONEXCLAMATION);
	dLog("*TextureEffect::openUrl failed!*");
	return false;
}
bool TextureEffect::download(){
	return false;
}

bool initWinINet(){
	//if((g_hInternetSession=InternetOpen(g_szAgent, INTERNET_OPEN_TYPE_PRECONFIG, 0, 0, INTERNET_FLAG_FROM_CACHE))!=NULL){
	if((g_hInternetSession=InternetOpen(g_szAgent, INTERNET_OPEN_TYPE_PRECONFIG, 0, 0, 0))!=NULL){
		dLog("g_hInternetSession!=NULL" );
		return true;
	}
	else{
		dLog("g_hInternetSession==NULL" );
		MessageBox(NULL, "Unable to open internet session for downloading files", NULL, MB_OK|MB_ICONERROR);
		return false;
	}
}

