#include <windows.h>
#include <vector>
#include <map>
#include <algorithm>

#include "seamless3d.h"
#include "techuelife_triangle_editor.h"

#include "gui.h"

#ifdef WACOM_FILES
#include "WacomMultiTouch.h"
#include "WintabUtils.h"
#define PACKETDATA	(PK_X | PK_Y | PK_BUTTONS | PK_NORMAL_PRESSURE)
#define PACKETMODE	PK_BUTTONS
#include "pktdef.h"
#endif


extern HWND hWndMain;
extern Vec2i g_mousePos;
extern bool g_winAPI3DMode;
extern ScenePtr g_scene;
extern BrushPtr g_brush;
extern bool g_useWinTab;

void mouse2dSync();
void hoverWin3d();

#ifdef WACOM_FILES
HCTX g_tabCtx = NULL;
PACKET* g_wintabPktBuf = 0;
#endif

//PACKET packetBuf[100];

int g_lastPacketIndex = -1;
extern int g_packetBufLen;
bool g_penEnabled = true;


void initPen(){
//	g_m_packet.length = 0x100;
#ifdef WACOM_FILES
	g_wintabPktBuf = new PACKET[0x100];
#endif
}

void disablePen(){
#ifdef WACOM_FILES
	if(g_useWinTab){
		BOOL flag = gpWTEnable(g_tabCtx, FALSE);
		g_penEnabled = false;
	}
#endif
}

void enablePen(){
#ifdef WACOM_FILES
	if(g_useWinTab){
		//gpWTPacketsGet(g_tabCtx, 0x200, NULL);
		BOOL flag = gpWTEnable(g_tabCtx, TRUE);
		g_penEnabled = true;

//	int len = gpWTPacketsGet(g_tabCtx, g_packetBufLen, g_wintabPkt);
//	if(len > 0){
//		int a = 0;
//	}
	//gpWTPacketsGet(g_tabCtx, 0x200, NULL);
	}
#endif
}


void emptyPacketQue(){
#ifdef WACOM_FILES
	if(g_useWinTab){
		BOOL flag = gpWTEnable(g_tabCtx, TRUE);
		//dLog(g_mousePos.x);
	

	//int packetBufLen = 0;
	//packetBufLen = gpWTQueueSizeSet(g_tabCtx, 0x80);
	//packetBufLen = gpWTQueueSizeGet(g_tabCtx);
	//packetBufLen = gpWTQueueSizeSet(g_tabCtx, 0x100);
	//packetBufLen = gpWTQueueSizeGet(g_tabCtx);
	}
#endif
}

void move3dMouse(){
	if(g_winAPI3DMode){
		return;
	}
	if(g_scene->mode & PAINT_MODE){
		if(g_scene->mode & BRUSH_MODE){
			g_brush->houseKeep();
		}
	}

	//if(g_winAPI3DMode){
		//dLog("WM_MOUSEMOVE");
		//moveMouse3d();
		//break;
	//}

	Button* hoverButton = Button::getHoverButton();
	MultiSelect::resetDistance();
	//if(g_insertPatch.imousePhase == LINE_MODE){
	//	mouse2dSync(hWndMain);
	//	//g_insertPatch.mouseOverPatch->getRatioPhaseForInsert();
	//	g_insertPatch.addInsertVisualClue();
	//}
	if(g_insertPatch.imousePhase == InsertPatch::MONITOR_DIRECTION){
		mouse2dSync();
		if(g_insertPatch.monitorDirection()){
			g_insertPatch.m_insert_tempDivertBackup = g_insertPatch.m_insert;
			g_insertPatch.m_insertOD_tempDivertBackup = g_insertPatch.m_insertOD;
			g_insertPatch.remLeftSide_tempDivertBackup = g_insertPatch.remLeftSide;

			g_insertPatch.beginInsertIdx_tempDivertBackup = g_insertPatch.beginInsertIdx;
			g_insertPatch.beginInsertIdxOD_tempDivertBackup = g_insertPatch.beginInsertIdxOD;
			g_insertPatch.imousePhase = InsertPatch::DIVERT_STANDBY;
		}
		return;
	}
	if(g_insertPatch.imousePhase == InsertPatch::STANDBY || g_insertPatch.imousePhase == InsertPatch::LINE_MODE || g_insertPatch.imousePhase == InsertPatch::DIVERT_STANDBY || g_addBone->mousePhase != AddBone::NEUTRAL){
		if(hoverButton){
			hoverButton->onHoverMove(g_mousePos - hoverButton->win.pos);
		}
		else{
			mouse2dSync();
			//SenseTugGlobals::initTug();
			if(NurbsPatch* patch = dynamic_cast<NurbsPatch*>(g_selNode.getRaw())){
				Seamless* smls = patch->smls;
				if(g_insertPatch.imousePhase == InsertPatch::DIVERT_STANDBY){
					if(smls->addDiversionMark()){
						//g_insertPatch.imousePhase = InsertPatch::TEMP_DIVERT;
					}
				}
				else{
					smls->insertControlRowColum();
				}
			}
			else if(g_addBone->mousePhase != AddBone::NEUTRAL){
				if(Art* part = dynamic_cast<Art*>(g_selNode.getRaw())){
					mouse2dSync();
					g_addBone->initMouseOverLine(part->smls);
				}
			}
		}
	}
	if(g_mergePatches.mousePhase == MergePatches::STANDBY){
		if(hoverButton){
			hoverButton->onHoverMove(g_mousePos - hoverButton->win.pos);
		}
		else{
			mouse2dSync();
			g_mergePatches.smls->mergePatchesStandby();
		}
	}
	if(g_deleteControlLine.mousePhase == 1 || g_deleteControlLine.mousePhase == 2){
		if(hoverButton){
			hoverButton->onHoverMove(g_mousePos - hoverButton->win.pos);
		}
		else{
			mouse2dSync();
			if(g_scene->mode & ANIMATION_MODE){
				if(Art* part = dynamic_cast<Art*>(g_selNode.getRaw())){
					part->smls->deleteControlLine();
				}
			}
			else if(NurbsPatch* patch = dynamic_cast<NurbsPatch*>(g_selNode.getRaw())){
				patch->smls->deleteControlLine();
			}
		}
	}
	else if(g_drag){
		if(g_mousePos.x >= 0){
			g_drag->doDrag(g_mousePos);
		}
	}
	else if(hoverButton && hoverButton->onHoverMove(g_mousePos - hoverButton->win.pos)){
	}
	else{
		hoverWin3d();
	}
}


void processPackets(){
#ifdef WACOM_FILES
	if(g_lastPacketIndex != -1){
		Vec2i ptNew;
		ptNew.x = g_wintabPktBuf[g_lastPacketIndex].pkX;
		ptNew.y = g_wintabPktBuf[g_lastPacketIndex].pkY;
		g_drawNurbsLine->mousePressure = g_wintabPktBuf[g_lastPacketIndex].pkNormalPressure;

		g_lastPacketIndex = -1;

		ScreenToClient(hWndMain, reinterpret_cast<POINT*>(&ptNew));
		g_mousePos.x = ptNew.x;
		g_mousePos.y = ptNew.y;
		g_newMousePos = g_mousePos;
	}
#endif
}

