/* Seamless3d

Copyright (C) 2001-2017 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#define MILISECONDS_TO_SECONDS 0.001f
//#define FRAME_TIME_SYNC 0.04f
//#define ROBOT_SYNC 1

#ifdef DEMO_TO_MOVIE
	#define FRAME_TIME_SYNC 0.04f
	//#define FRAME_TIME_SYNC 0.12f
	#define ROBOT_SYNC 1
#endif


extern float g_mouseSense;

#define CROSS_OVER_AMOUNT .000001

extern char choseWrlFirst[];
extern char choseAll3dTypes[];

void incToNextTriThatSharesActivePoint();
void decToNextTriThatSharesActivePoint();

void rotate_uv_90();
void mirrorCtrlPoints();
void mirrorMorphedCtrlPoints();
void pasteCtrlPoints();
void pasteCtrlPointsMirror();
void setAllWeightsToOne();
void insideOutPatch();
void flipPolarity();

void compileTransform();
void compileScale();
void compileScaleRotation();
void immediateDeleteVertex();
void replaceWithCopyOfRememberedPart();
void replaceWithCopyOfPolyMapMirrorX();
void replaceWithCopyOfRememberedPartMirrorX();
void replaceWithCopyOfRememberedPartMirrorY();
void replaceWithCopyOfRememberedPartMirrorZ();
void copyAndPasteMirroredPart();
//void permanentTransform();
//void localPermanentTransform();
void zeroVetexX();
void mirrorVertexX();
void mirrorVertexY();
void mirrorVertexZ();

#ifdef PROG_ROB
struct StoreCrossPoint{
	int idxA;
	int idxB;
	float ratio;
	bool active;
	void set(int _idxA, int _idxB, float _ratio){
		active = true;
		idxA = _idxA;
		idxB = _idxB;
		ratio = _ratio;
	}
};
extern StoreCrossPoint g_storeCrossPoint;
#endif
extern Vec2i g_extraWinPix;


//void snapSinglePointToRem();
extern int undoUniqueNameCntr;
extern const String g_undoDir;
extern const String g_screenshotDir;

void setSmlsSaved();
bool resetTemporaryModes();
extern char defaultMsg[];

//extern HWND hWndMain;
//extern HINSTANCE  g_hinst;

//extern HMENU g_hf10Menu;
//extern BOOL g_localControl;
extern bool mouse3dMode;
void deleteTriangle();


extern GeomRenderPtr g_redPoint;
extern GeomRenderPtr g_lastPoint;
extern GeomRenderPtr g_nextPoint;
extern GeomRenderPtr g_yellowPoint;
extern GeomRenderPtr g_cyanPoint;
extern GeomRenderPtr g_redConePoint;
extern GeomRenderPtr g_greenConePoint;
extern GeomRenderPtr g_blueConePoint;


extern ScenePtr g_scene;
class Pointer{
public:
	Vec3f translation;
	Vec3f remTranslation;
	//Rotation rotation;
	//Vec3f scale;
};
extern Pointer g_pointer;
//extern ArtPtr rootJoiner;
//extern SeamlessPtr g_seamless;
extern NodePtr g_before;

extern ArtPtr remPJ;
void drag(Seamless* sm, Vec3f pt);
void makePointerEqualIndexLocation();
ArtPtr selectPartFromVertex(SeamlessPtr sm, int targetVertex);
//bool updateAllVertexInBuffers(ArtPtr part);
extern S_Triangle triVertexRem;
extern Rect clientOffest;


extern M_Int g_copyIndex;

extern Node* g_visualClue;
extern TransformPtr g_cursorOverPointIlsBase;

//extern SeamlessPtr g_vcSeamless;
//extern ArtPtr g_vcPart;
//extern StemPtr g_vcStem;
//extern SurfaceGeneratorPtr g_vcSurface;
//extern CCLathePtr g_vcCCLathe;
//extern SurfaceTransformPtr g_vcSurfaceTransform;
//extern CCBendPtr g_vcCCBend;
//extern SurfaceTransformPtr g_vcBaseRad;
void houseKeepVisualClue();
void houseKeepVisualClueViewChange();
//extern bool g_spaghetti;
extern Stem* g_radialTugStem;
extern RadialTug* g_radialTug;
extern Ptr<Radial_Tug> g_radial_Tug;
extern Ptr<RadicalPatch> g_radicalPatch;
extern int g_wireFrameMode;
void radialTug(Vec3f coord, Vec3f pt);
//bool isMasterModeCCLathe(CCLathePtr lathe);
bool isMasterModeStem(StemPtr stem);
Stem* getStemOwner();
void nextTriangle();
void prevTriangle();
void cut();
void remember();

bool getOldColor(Color3f& oldColor);
void showCursor(bool show);
extern Matrix g_viewMatrix;
void splitPath(String wholePath, String& drive, String& dir, String& fname, String& ext);
extern String g_seamlessDir;
extern Color3f g_bColor;
IndexedTriangleSet* convertToTriangleSet(MeshPtr gs);
void genCone(float height, float radius, bool side, bool bottom, int staves, Mesh& geomSource, Effect* effect);
void genSphere(float radius, int staves, int bands, Mesh& geomSource, Effect* effect);
void genCylinder(float height, float radius, bool side, bool top, bool bottom, int staves, int bands, Mesh& geomSource, Effect* effect);
void genBox(Vec3f size, int staves, int bands, Mesh& geomSource, Effect* effect);
//void genGridZ(Mesh& geomSource, float xDistance=1, float yDistance=1, int xPointCnt=2,int yPointCnt=2, int flags =0);
void setTitleName();
extern float g_viewDist;
//inline Matrix getIViewRotScaleMatrix(){
//	return scaleMatrix(Vec3f(1./g_scene->scale.x, 1./g_scene->scale.y, 1./g_scene->scale.z)) * rotationMatrix( -g_scene->rotation);
//}
inline Matrix Scene::getIViewMatrix(){
	return scaleMatrix(Vec3f(1./scale.x, 1./scale.y, 1./scale.z)) * rotationMatrix( -rotation) * translationMatrix(-translation);
}
inline Matrix Scene::getViewMatrix(){
	//return scaleMatrix(g_scene->scale) * translationMatrix(g_scene->translation) * rotationMatrix(g_scene->rotation);
	return translationMatrix(translation) * rotationMatrix(rotation) * scaleMatrix(scale);
}

extern Matrix g_catchMatrix;
extern Matrix g_catchIMatrix;
extern bool g_bReady;
void initializeScript();
void initCompile();
void decodeFunctions(const String& str);
extern SettingsPtr g_settings;
extern Ptr<TransformCP> g_transformCP;
extern Ptr<TransformObj> g_transformObj;
extern Ptr<AnimLever> g_vcArtAnimBase;
extern bool g_online;
extern bool g_viewer;
extern int g_rememberIndex;


void findThinTriangle(Seamless* smls);
void needPartMsg();
void needPartOrSmlsMsg();
void needPartCopiedMsg();
void commonEndVertexChange();
void replaceColorInPart(ArtPtr part, Color3f oldColor, Color3f newColor);
void transferCloseVertices();
void transferCloseVerticesJoin();
void joinCloseVerticesMacro();
void averagePivotPoint();
void findLayeredTriangle();
void help();//HELP
void about();//ABOUT
void openSceneTree();	//IDD_SCENE_TREE_WINDOW
void openControlPanel();
void openNetFile();//	OPEN_NET_FILE
void fastBuild();
void fullBuild();
void pivotPointToClipBoard();
//void spaghetti();	//SPAGHETTI
void invertBackgroundColor();//TOGGLE_BACKGROUND
void toggleWireFrame();	//WIRE_FRAME_MODE
void toggleNSPE();
void findThinTriangle();//FIND_THIN_TRIANGLE
void selectPreviousVertex();//SELECT_PREV_VERTEX
void selectNextVertex();//SELECT_NEXT_VERTEX
#define selectPrevNextVertex selectPreviousVertex

void prevTriangle();//SELECT_PREV_TRI
void nextTriangle();//SELECT_NEXT_TRI
void selectPreviousCornerInTri();//SELECT_PREV_CORNER_IN_TRI
void selectNextCornerInTri();//SELECT_NEXT_CORNER_IN_TRI
void decToNextTriThatSharesActivePoint();//DEC_TO_NEXT_SHARED_TRI
void incToNextTriThatSharesActivePoint();//INC_TO_NEXT_SHARED_TRI
void moveVertex();//MOVE_VERTEX
void forceToMirrorX();//FORCE_TO_MIRROR_X
void joinVertexKeepDestColor();//JOIN_VERTEX //JOIN_COLOR
void joinVertexKeepSourceColor();
void joinVertexKeepBothColors();//JOINVERTEXREMCOLOR
void exportColorToTexture();
void storeGeneratedPolyMap();
void copyColorToPolyMap();
void pasteToPolyMap();
void mirrorHalfPolyMap();
void addMirrorHalfPolyMap();
void deletePolyMap();
void deleteHalfPolyMap();
void saveTextureFile();
extern bool g_dragActuallyHappened;


void zeroVetexX();//ZERO_TO_X
void colorVertex();//COLOR_VERTEX
void pasteColorToTriangle();
void joinMatchingColors();//JOIN_MATCHING_COLORS
void colorPart();//COLOR_PART
void replaceColorPart();//REPLACE_COLOR_PART
void replaceColorSkeleton();//REPLACE_COLOR_SKELETON
void transferSingleVertex();//		TRANSFERSINGLEVERTEX
void transferPartVertex();//		TRANSFERPARTVERTEX
void transferCloseVertices();//		TRANSFERCLOSEVERTICES
void transferCloseVerticesJoin();//	 TRANSFERCLOSEVERTICES_JOIN
void replaceWithCopyOfRememberedPartMirrorX(); //REPLACE_WITH_REMBERED_PART_CONVERTED_MIRROR_X
void replaceWithCopyOfRememberedPartMirrorY();//REPLACE_WITH_REMBERED_PART_CONVERTED_MIRROR_Y
void replaceWithCopyOfRememberedPartMirrorZ();//REPLACE_WITH_REMBERED_PART_CONVERTED_MIRROR_Z
void pasteAddCopyOf();
void pasteAddCopyOfMirrorX();//ADD_CONVERTED_MIRROR_X_PART
void pasteAddCopyOfMirrorY();//ADD_CONVERTED_MIRROR_Y_PART
void pasteAddCopyOfMirrorZ();//ADD_CONVERTED_MIRROR_Z_PART
void buildSphereForSelPart();//GEN_SPHERE
void buildCylinderForSelPart();//GEN_CYLINDER
void buildConeForSelPart();
void buildRingsForSelPart();
void buildTorusForSelPart();
void buildBezierLatheForSelPart();
void buildBoxForSelPart();
void genTriangle();//GEN_TRIANGLE
void newRectangle();//GEN_FLAT
void buildNurbsLatheForSelPart();
void buildAvSegmentForSelPart();
void buildBendyLatheForSelPart();
void addHairNodeForSelPart();
void addNurbsLine();
void drawNurbsLine();
void toggleCreateMirrorObjectMode();
void toggleDragWithDescendantsMode();
void buildSubdivisionForSelPart();
void buildModelMorpherForSelSmls();
void copyPartForSelParts();
void placeForSelParts();
void colorSweepForSelParts();
void swapVertexOrderDec();//SWAP_VERTEX_ORDER_DEC
void swapVertexOrderInc();//SWAP_VERTEX_ORDER_INC
void breakVertexJoin();//BREAK_COORD_JOIN
void breakColorJoin();//BREAK_COLOR_JOIN
void immediateDeleteVertex();//DELETE_VERTEX
void deleteTriangle();//DELETE_TRI
void cutRightFromVertex();//CUT_AWAY_RIGHT
void cutLeftFromVertex();//CUT_AWAY_LEFT
void cutUpFromVertex();//CUT_AWAY_UP
void cutDownFromVertex();// CUT_AWAY_DOWN
void cutWholePart();//CUT_WHOLE_PART
void splitTriangleImmediate();//SPLIT_TRI
void projectSingleVertexOntoPoly();
void mirrorTriangleImmediate();//MIRROR_TRI
void swapDivide();// SWAP_DEVIDE:
void lightenVertex();//LIGHTEN_VERTEX
void darkenVertex();//DARKEN_VERTEX
void compileScale();//COMPILE_SCALE
void compileScaleRotation();//COMPILE_SCALE_ROTATION
void floorBuild();
void outputPovRayMovie();
void outputScreenShotMovie();
void outputScreenShotSingle();
void outputBatchFile();
void reduceCapturedPoses();
void convertToPatch();
void convertToBendy();
void convertPivotPointsToTranslations();
void convertTranslationsToPivotPoints();
void straightenBones();

void mercatorToNorthPole();
void mercatorToSouthPole();
void northPoleToMercator();
void southPoleToMercator();
void poleToPole();

void reverseIndices();//REVERSE_INDICES
void doBuild();//DOBUILD
void resetRotations();//RESET_ROTATIONS
void openSettings();//MODES
void togglePerspective();//PERSPECTIVE_BUTTON:
void openGridControl();

void decCoordX();
void incCoordX();
void decCoordY();
void incCoordY();
void decCoordZ();
void incCoordZ();

void decRed();//DEC_RED:
void incRed();//INC_RED:
void decGreen();//DEC_GREEN:
void incGreen();//INC_GREEN:
void decBlue();//DEC_BLUE:
void incBlue();//INC_BLUE:

void zoom();//ZOOM_OUT
void zoomIn();//ZOOM_IN
void openPalette();
void openOwnership();
void setPaintColorCodedControlPoints();
void unMultiSelTri();
void toggleMultiSelectTriVert();

/*
void decViewOrientationX();//DEC_VIEW_ORIENTATION_X	//[
void incViewOrientationX();//INC_VIEW_ORIENTATION_X	//]
void decViewOrientationY();//DEC_VIEW_ORIENTATION_Y	//;
void incViewOrientationY();//INC_VIEW_ORIENTATION_Y	//'
void decViewOrientationZ();//DEC_VIEW_ORIENTATION_Z	//.
void incViewOrientationZ();//INC_VIEW_ORIENTATION_Z	///
void decViewOrientation90X();//DEC_VIEW_ORIENTATION_90_X
void incViewOrientation90X();//INC_VIEW_ORIENTATION_90_X
void decViewOrientation90Y();//DEC_VIEW_ORIENTATION_90_Y
void incViewOrientation90Y();//INC_VIEW_ORIENTATION_90_Y
void decViewOrientation90Z();//DEC_VIEW_ORIENTATION_90_Z
void incViewOrientation90Z();//INC_VIEW_ORIENTATION_90_Z
void decViewPositionX();//DEC_VIEW_POSITION_X
void incViewPositionX();//INC_VIEW_POSITION_X
void decViewPositionY();//DEC_VIEW_POSITION_Y
void incViewPositionY();//INC_VIEW_POSITION_Y
void decViewPositionZ();//DEC_VIEW_POSITION_Z
void incViewPositionZ();//INC_VIEW_POSITION_Z
*/

void beamTo();
void convertToWhitePart();
void convertToImmediatePart();
void convertAllToImmediateParts();

void decPivotX();//DEC_PIVOT_X
void incPivotX();//INC_PIVOT_X
void decPivotY();//DEC_PIVOT_Y
void incPivotY();//INC_PIVOT_Y
void decPivotZ();//DEC_PIVOT_Z
void incPivotZ();//INC_PIVOT_Z
#define movePivotPoint decPivotX

void buildF10Menu(); //POPUP_MENU
void openNodeWindow(); //OPEN_NODE_WINDOW

void decTugRadius(); //DEC_RADIUS
void incTugRadius(); //INC_RADIUS
void quickTriangle();

void incCaret();
void decCaret();
void homeCaret();
void endCaret();
void deleteChar();

void incCaretShift();
void decCaretShift();
void homeCaretShift();
void endCaretShift();
void deleteCharShift();

void setZDragNode();
extern bool g_zDragMode;

enum ShortCuts{
	DEC_VIEW_ORIENTATION_X,
	INC_VIEW_ORIENTATION_X,
	DEC_VIEW_ORIENTATION_Y,
	INC_VIEW_ORIENTATION_Y,
	DEC_VIEW_ORIENTATION_Z,
	INC_VIEW_ORIENTATION_Z,
	RESET_ORIENTATION,
	DEC_VIEW_POSITION_X,
	INC_VIEW_POSITION_X,
	DEC_VIEW_POSITION_Y,
	INC_VIEW_POSITION_Y,
	DEC_VIEW_POSITION_Z,
	INC_VIEW_POSITION_Z,
	RESET_POSITION,
	BUILD_TEXTURED_OBJECT,
};

bool keyDown(unsigned key);
bool keyDownAlt(unsigned key);
bool keyDownCtrl(unsigned key);
bool keyDownShift(unsigned key);

class BackUp{
	static int backedUpFileCntr;
	static int backedUpFileCntrEnd;
public:
	static String ourBackUpName;
//	static void resetSmlsSaved();//***** do we really want this as a member of BackUp?
	static void deleteBackupFiles();
	static void createUniqueBackupName(bool copy = false);
	static void commonUndoRedo();
	static void unDo();
	static void reDo();

	class Monostable{
		bool beginBool;
		double beginTime;
	public:
		Monostable():
			beginBool(false),
			beginTime(0)
		{}
		void beginCycle();
		void clear(){
			beginBool = false;
		}
		bool state()const;
	};
	class SmlsSaved{
		int currentSavedPoint;
	public:
		SmlsSaved():
			currentSavedPoint(0)
		{}
		void set(){
			currentSavedPoint = backedUpFileCntr;
		}
		void unSet(){
			currentSavedPoint = -1;
		}
		operator const bool ()const{
			return currentSavedPoint==backedUpFileCntr;
		}
	};
	static SmlsSaved smlsSaved;

	static Monostable monostable;

	static void backupToCache(bool copy = false);
	inline static void checkForBackUpOperation();
};

bool getTriangleHitPos(Vec3f& clickPos, const Vec2f& pt, const Vec3f* v);
bool isTriangleHit(const Vec2f& pt, const Vec2f* v);

struct SenseTugGlobals{
	static Node* node;//which node to select and type of node slected, if 0 no hit has been detected
	static Art* actTriPart;
	static Vec3f pointer;
	static int ActTri;
	static float hitZ;
	static float ratio;
	static bool uLine; // vLine if false
	static Vec3f clickPos;
	static int corner;
	static int ActCtrlPnt;
//	static bool sameVertexHit;
	static void initTug();
	static void initMidTug();
};

void decViewOrientationX();//DEC_VIEW_ORIENTATION_X	//[
void incViewOrientationX();//INC_VIEW_ORIENTATION_X	//]
void decViewOrientationY();//DEC_VIEW_ORIENTATION_Y	//;
void incViewOrientationY();//INC_VIEW_ORIENTATION_Y	//'
void decViewOrientationZ();//DEC_VIEW_ORIENTATION_Z	//.
void incViewOrientationZ();//INC_VIEW_ORIENTATION_Z	///
void decViewOrientation90X();//DEC_VIEW_ORIENTATION_90_X
void incViewOrientation90X();//INC_VIEW_ORIENTATION_90_X
void decViewOrientation90Y();//DEC_VIEW_ORIENTATION_90_Y
void incViewOrientation90Y();//INC_VIEW_ORIENTATION_90_Y
void decViewOrientation90Z();//DEC_VIEW_ORIENTATION_90_Z
void incViewOrientation90Z();//INC_VIEW_ORIENTATION_90_Z
void decViewPositionX();//DEC_VIEW_POSITION_X
void incViewPositionX();//INC_VIEW_POSITION_X
void decViewPositionY();//DEC_VIEW_POSITION_Y
void incViewPositionY();//INC_VIEW_POSITION_Y
void decViewPositionZ();//DEC_VIEW_POSITION_Z
void incViewPositionZ();//INC_VIEW_POSITION_Z


void togglePolyMorphCapture();
void setFrontViewOrientation();
void setBackViewOrientation();
void setLeftViewOrientation();
void setRightViewOrientation();
void setBirdsEyeViewOrientation();
void setWormsEyeViewOrientation();
void quantiseViewOrientation();

#define viewOrientation decViewOrientationX
#define viewOrientation90 decViewOrientation90X
#define viewPosition decViewPositionX

void resetViewPosition();//RESET_POSITION
void resetViewOrientation();//RESET_ORIENTATION

void centerViewToPivotPoint();//CENTRE_PART_VIEW
void centerViewToControlPoint();
void openTransformCP();
void commonCenterViewToPivotPoint(Art* part);

void reset3dScene();//RESET_ALL	VK_ESCAPE:
void unDo();
void reDo();
extern String g_upStr;
void fastFullBuildForAutoIn(bool inState);
void fastFullBuildForAutoIn(bool inState, Seamless* smls);
int findNextTriangleFromVertex(Art* vertexPart, Art*& triPart, const int vertexIndex, int &corner, int triangleIndex=-1);
int findPrevTriangleFromVertex(Art* vertexPart, Art*& triPart, const int vertexIndex, int &corner, int triangleIndex=-1);
Seamless* getSeamless2();
Hair* getHair(int selLine);
Hair* getHair();

extern Ptr<QuestionMessage3Button> g_questionMessage3Button;
extern Ptr<Message1Button> g_message1Button;
extern bool g_forceSaveAs;

void toggleStitchPolyMode();
void deleteSelectedPatches();

void helpMenu();
void saveSmlsFirst(void (* i_queFunction)());
void newSmls();
void openSmls();//can also open wrl, wrz, x3dv, x3dv, bvh & mid
void fileMenu();
void saveSmls();
void saveSmlsAs();
void importPart();
void exportPart();
void importPatch();
void exportPatch();
void exportBVH();
void exportColorToTexture();
void toggleXRayMode();
void moreModellingMenu();

void insideOutPart();

void extrudePatch();
void insertControlPoint();
void deleteControlPoint();
void cutPatches();
void incorporate();
void mergePatches();
void kutPatches();
void rotateCtrlStaves();
void fillet();
void createDoubleSurface();
void generateRawStitchPolys();
void convertToColorPatches();
void pasteColumn();
void transferSelectedPoints();
void deletePoliesOwnedByPatch();
void selectRing();
void selectWholePatch();
void toggleSelectRing();
void toggleSelectRings();
void showAllCages();
void showSingleCage();
void showSelectedGroups();
void hideSelectedCages();
void hideSelectedGroups();
void alignMidSelectededPoints();
void invertSelCtrlPoly();
void rotateRegion();
void splitTriangleImmediate();
void splitLock();

void repeatSeperatorMap();
void autoLengthStrands();
void seedStrandsInSelRegions();
void deleteStrandsInSelRegions();

void deleteNode();

extern bool skeletonMode;

extern String g_currentFilename;

enum{
	ONLY_ANIMATION = 1,
	ONLY_BUILD = 2,
	RECALC = 4, 
	IMPORT_PIVOT_POINTS = 8,
	IMPORT_PIVOT_POINTS_DISTANCES = 0x10,

	IMPORT_CHILD = 1,
	IMPORT_ABOVE = 2,
	IMPORT_REPLACE = 3,
	IMPORT_BELOW = 4
};

void toggleBackfaceSelect();
void toggleAccumulateSelect();
extern bool g_hidePolysInHiddenPatches;
void toggleHidePolysInHiddenPatches();
void reRenderPolysIfInHidePolyMode();

inline Vec2f procPerspective(const bool& perspective, const Vec3f& sr){
	if(perspective){
		return Vec2f(sr.x / (-sr.z + g_viewDist), sr.y / (-sr.z + g_viewDist));
	}
	return Vec2f(sr.x, sr.y);
}


inline Vec2f get2dCoord(const Vec3f& point, const int& perspective){
	Vec3f crd3f = g_scene->getViewMatrix() * point;
	Vec2f crd;
	if(perspective){
		crd=Vec2f(
			crd3f.x/(-crd3f.z + g_viewDist),
			crd3f.y/(-crd3f.z + g_viewDist)
		);
	}
	else{
		crd=Vec2f(crd3f.x, crd3f.y);
	}
	return crd;
}

int getParent(int selLine);
Node* getParentNode(int selLine);
void relateHitPointToMapTri(Vec2f sa, Vec2f sb, Vec2f sc, Vec2f& hit, Vec2f ta, Vec2f tb, Vec2f tc);

extern InsertPatch g_insertPatch;
extern DeleteControlLine g_deleteControlLine;
extern MergePatches g_mergePatches;
extern Ptr<AddLathe> g_addLathe;
extern AddBox g_addBox;
extern AddSphere g_addSphere;
extern Ptr<Duplicate> g_duplicate;
extern Ptr<AddNurbsLine> g_addNurbsLine;
extern Ptr<DrawNurbsLine> g_drawNurbsLine;
extern Ptr<AddBone> g_addBone;
extern bool g_rectangleSelectPointReady;
extern bool g_rectangleUnselectPointReady;
extern bool g_rectangleSelectPolyReady;

void bnspeBuildPolies();
void bnspeBuildPolies(Hair* hair);

void openBrush();
void openFill();
void openColorPicker();
void hideShowMesh();

extern bool g_insertControlPoint;
extern bool g_deleteControlPoint;
extern bool g_perspective;
extern bool g_panViewMode;

void setEnableMorphCapture();
void setPolyEditMode();
void setModellingMode();
void togglePanViewMode();
void setPaintMode();
void setHomeMode();
void setSelectObjectMode();
void setAnimationMode();
void setXRayEditMode();
void setAddBoneMode();
void toggleBoxPatchModellingMode();
void toggleShowPatchBordersMode();
void setSingleActiveMode();
void toggleZBufferCageMode();
void toggleCurvedCageMode();
void playAnim();

bool controlKeyState();
bool shiftKeyState();
bool altKeyState();
bool zKeyState();
bool aKeyState();
bool sKeyState();
bool dKeyState();
bool r_controlKeyState();
bool r_shiftKeyState();
bool r_altKeyState();
bool deleteKeyState();
bool tabKeyState();
bool enterKeyState();

extern int g_lockFile;

extern bool g_penEnabled;
void enablePen();
void disablePen();
void setMouseCapture();
struct WavHeader{
	char chunkID[4];        //Contains the letters "RIFF" in ASCII form (0x52494646 big-endian form).
	int chunkSize;			//36 + SubChunk2Size, or more precisely: 4 + (8 + SubChunk1Size) + (8 + SubChunk2Size)
                            //This is the size of the rest of the chunk 
                            //following this number.  This is the size of the 
                            //entire file in bytes minus 8 bytes for the
                            //two fields not included in this count:
                            //ChunkID and ChunkSize.
	char format[4];				//Contains the letters "WAVE"  (0x57415645 big-endian form).
//The "WAVE" format consists of two subchunks: "fmt " and "data":
//The "fmt " subchunk describes the sound data's format:

	char subchunk1ID[4];		//Contains the letters "fmt " (0x666d7420 big-endian form).
	int subchunk1Size;    //16 for PCM.  This is the size of the
                         //      rest of the Subchunk which follows this number.
	short int audioFormat;      //PCM = 1 (i.e. Linear quantization)
                               //Values other than 1 indicate some form of compression.
	short int numChannels;	//Mono = 1, Stereo = 2, etc.
	int sampleRate;				//8000, 44100, etc.
	int byteRate;			//SampleRate * NumChannels * BitsPerSample/8
	short int blockAlign;      //NumChannels * BitsPerSample/8
                               //The number of bytes for one sample including all channels. I wonder what happens when this number isn't an integer?
	short int bitsPerSample;
};


struct WriteWavHeader{
	char chunkID[4];        //Contains the letters "RIFF" in ASCII form (0x52494646 big-endian form).
	int chunkSize;			//36 + SubChunk2Size, or more precisely: 4 + (8 + SubChunk1Size) + (8 + SubChunk2Size)
                            //This is the size of the rest of the chunk 
                            //following this number.  This is the size of the 
                            //entire file in bytes minus 8 bytes for the
                            //two fields not included in this count:
                            //ChunkID and ChunkSize.
	char format[4];				//Contains the letters "WAVE"  (0x57415645 big-endian form).
//The "WAVE" format consists of two subchunks: "fmt " and "data":
//The "fmt " subchunk describes the sound data's format:

	char subchunk1ID[4];		//Contains the letters "fmt " (0x666d7420 big-endian form).
//16 bytes

	int subchunk1Size;    //16 for PCM.  This is the size of the
                         //      rest of the Subchunk which follows this number.
	short int audioFormat;      //PCM = 1 (i.e. Linear quantization)
                               //Values other than 1 indicate some form of compression.
	short int numChannels;	//Mono = 1, Stereo = 2, etc.
	int sampleRate;				//8000, 44100, etc.
	int byteRate;			//SampleRate * NumChannels * BitsPerSample/8
//16 bytes

	short int blockAlign;      //NumChannels * BitsPerSample/8
                               //The number of bytes for one sample including all channels. I wonder what happens when this number isn't an integer?
	short int bitsPerSample;

	char data[4];
	int sampleLen; //sample length in bytes
//	12 bytes


};
